For "BSGP"{}
using meta
const
	version=__hack__"BSGP version"
static detail{
#defhack __spawn__ 'bsgp-spawn'
#defhack __barrier__ 'bsgp-barrier'
#defhack __require__ 'bsgp-require'
#defhack __endreq__ 'bsgp-endreq'
#defhack __endspawn__ 'bsgp-endspawn'
#defhack __settsize 'bsgp-setsize'
#defhack __gettsize 'bsgp-getsize'
//load/store point shouldn't be necessary
#defhack __getrank 'bsgp-getrank'
#defhack __BSgotonext 'bsgp-BSjmp'
#defhack __BSpoint 'bsgp-BSlbl'
//pass the content instead of pointer of a named pointer
#defhack __byvalue 'bsgp-byvalue'
//0 for begin, 1 for clause, 2 for end
#defhack __parblock 'bsgp-parblock'
#defhack __setoldrank 'bsgp-setoldrank'
#defhack __getoldrank 'bsgp-getoldrank'
#defhack __commget 'bsgp-commget'
#defhack __commput 'bsgp-commput'
//internal
#defhack __skipit 'bsgp-skipit'
#defhack __getsztot 'bsgp-getsztot'
#defhack __inlepos 'bsgp-inlepos'
//configuration
__SPMBszsm=0
lvec(cfunction*) tocomp
void bsgpfinhook()
	bk=meta.curtarget
	meta.curtarget=meta.state("target-BSGP")
	//.tocomp.n may change during compilation
	for(i=0;i<.tocomp.n;i++)
		f=.tocomp.d[i]
		meta.compile(f)
	meta.curtarget=bk
/
	.tocomp.init()
	meta.state('bsgp-finhook')=bsgpfinhook
For "portable" inline pure1()
	__pure__
	return 1
}
using detail
//spawn n
def spawn:
	if got(tok_str)||got(int'{'):
		//empty spawn
		ftran=(void()())meta.state('metaf-transpawntask')
		if !ftran:
			write-errorf("task parallelism isn't supported on target ",((ctarget*)meta.state("BSGP-defaulttarget")).name)
		ftran()
		return
	fhook=(void()(int))meta.state('bsgp-spawn-hook')
	if !meta.curfunc:error('spawn has to be in function')
	//translate n into expr to avoid scope problem
	li=getlineinfo()
	ern=assexpr()
	li2=getlineinfo()
	pepos=meta.epos
	s2=gettext(gt_block|gtf_code)
	/*
	note:
		krnlid is useless to spmb kernels, but have to be ++ed to ensure
		correct texture binding
	*/
	f=meta.curfunc.f
	if meta.state('bsgp-state-inspawn'):
		error("nested spawn is not allowed")
	if f.ccnv>=cfunction.cv_inline:
		error("spawn isn't supported in inline function yet")
	meta.state('bsgp-state-inspawn')=void*1
	if !f.estate('has-spawn'):
		detail.tocomp.add(f)
		f.estate('has-spawn')=void*1
	emitcode_clear()
	bk=meta.curtarget
	bk2=meta.spectarget
	meta.curtarget=state("BSGP-defaulttarget")
	meta.spectarget=state("BSGP-defaulttarget")
	if fhook:fhook(0)
	write-emitcodef(;"{",li2,"$$bsgp.detail.__spawn__(iptr ",
		(iptr)pepos,");",
		"if $$bsgp.detail.pure1():{",
		"$$bsgp.require{$$bsgp.thread.size=(",li)
	emitcode_expr(ern)
	//<=0 check is mandatory, not optimization
	write-emitcodef(;");if $$bsgp.thread.size<=0:{$$bsgp.detail.__skipit()}}}",
		s2,
		"/{$$system.meta.curtarget=void*",iptr bk,";",
		"$$system.meta.spectarget=void*",iptr bk2,";")
	if fhook:
		write-emitcodef(;"((void()(int))",(iptr)fhook,")(1);")
	write-emitcodef(;"}$$bsgp.detail.__endspawn__();}")
	emitcode_flush()
	//require may instantize a template that uses spawn...
	$$system.meta.state('bsgp-state-inspawn')=null;
	feedstat(statement())
with detail
	ccode require_wrap(int what,ccode code)
		//pure1 if wrap
		code=makeif(&call('$$bsgp.detail.pure1',new cvec(cexpres*)),code,null)
		return cat(call('$$bsgp.detail.__require__',List[&makeeri(what)]).code,
			cat(code,
			call('$$bsgp.detail.__endreq__',new cvec(cexpres*)).code))
def require:
	what=0
	isstr=0
	if want(int'('):
		if meta.state('bsgphk-tagreqex')&&got(tok_str):
			what=(iptr)wantstr()
			isstr=1
		else
			what=!!cnsexpr()
		skip(int')')
	elif meta.state('bsgphk-tagreqex')&&got(tok_str):
		what=(iptr)wantstr()
		isstr=1
	if !got(tok_indl):skip(int':')
	bk=meta.curtarget;bk2=meta.spectarget
	if isstr:
		tar=meta.target_native
		s=(char*)what
		sdot=strchr(s,int'.')
		if sdot:
			strcpy(char[64]buf,"target-")
			memcpy(buf+7,s,sdot-s)
			buf[sdot-s+7]=0
			tar=meta.state(buf)
			if !tar:tar=meta.target_native
		meta.curtarget=tar
		meta.spectarget=tar
	else
		meta.curtarget=meta.target_native
		meta.spectarget=null
	st=statement_noscope()
	initcode=ccode null
	donecode=ccode null
	if meta.curfunc.spectarget&&!(ctarget*meta.curfunc.spectarget).supportclass:
		//only makes sense for inlined-in device function
		strptr_scan(st,initcode,donecode)
	meta.curtarget=bk;meta.spectarget=bk2
	code=ccode null
	if initcode:code=cat(code,require_wrap(2,initcode))
	code=cat(code,require_wrap(what,st))
	if donecode:code=cat(code,require_wrap(3,donecode))
	feedstat(code)
def barrier:
	d=0
	if want(int'('):
		d=cnsexpr()
		skip(int')')
	emitcode_clear()
	write-emitcodef(;"$$bsgp.detail.__barrier__(",d,");")
	emitcode_flush()
const
	RANK_REASSIGNED=1
static thread
	For "portable"
		iptr rank
			%get()=detail.__getrank()
		iptr size
			%get()=detail.__gettsize()
			For "native" %set(iptr a)detail.__settsize(a)
		iptr oldrank
			%iptr get()=detail.__getoldrank()
			%set(iptr a)detail.__setoldrank(a)
def par:
	//if strcmp(meta.curtarget.name,"PTX")!=0:error("par block can only be used on device")
	first=1
	want(int':')
	skip(tok_indl)
	st=ccode null
	while !want(tok_indr):
		st=cat(st,call('$$bsgp.detail.__parblock',List[&makeeri(!first)]).code)
		st=cat(st,statement())
		first=0
	st=cat(st,call('$$bsgp.detail.__parblock',List[&makeeri(2)]).code)
	feedstat(st)
def Interrupt:
	tar=meta.curtarget.name
	pmf=meta.curfunc
	if !pmf||!pmf.f:error('BSGP interrupt has to be a device function')
	pf=pmf.f
	if pf.t==t0_unknown||pf.t==t0_unknownref||pf.t==t0_unknowncref:
		error('return type has to be defined before the interrupt statement')
	char[260]buf
	write-sprintf(buf;tar,'-bsgp-interruptFE')
	(void()(cfunction*)meta.state(buf))(pf)
static interrupt
#def __def_tempsize:
	which=0
	if want(int'(')
		which=cnsexpr()
		skip(int')')
	pe=&expr()
	if pe.what!=cexpres.indef||pe.idef.what!=cindef.data||pe.t!=t0_iptr:
		error("initialized global integer variable expected after __def_tempsize")
	addr=(iptr)pe.idef.pinit.pdata
	emitcode_begin()
	emitcode("require{")
	emitcode_expr(&call('$$bsgp.detail.__getsztot',List[&makeeri(which),&makeeri(addr)]))
	emitcode(";}")
	emitcode_end()
#def #target:
	tarstr=wantstr()
	tar=(ctarget*)meta.state((char*)write-strprintf('target-',tarstr))
	if !tar:write-errorf("can't find target ",tarstr)
	meta.curtarget=tar
	meta.spectarget=tar
	fstt=(cmetaf*)meta.state('bsgp-settarget')
	feedstat(cons(makeccd(fstt,null,List[copr.I((iptr)tar)])))
