uses spap
autouses spap
/meta.enableTarget("CUDA",1)
static detail
using detail
with detail{
#define aprelive /{meta.curfunc.flags_version|=meta.cfunc.trait_prelive}
#define __cuintrinsic__ For "PTX" __intrinsic__
}
__cuintrinsic__ int __float2int_rn(float a){}
__cuintrinsic__ int __float2int_rz(float a){}
__cuintrinsic__ int __float2int_ru(float a){}
__cuintrinsic__ int __float2int_rd(float a){}
__cuintrinsic__ float floorf(float a){}
__cuintrinsic__ float ceilf(float a){}
with system{
For "PTX" %int ceili(float a)=__float2int_ru(a)
For "PTX" %int floori(float a)=__float2int_rd(a)
For "PTX" %float ceil(float a)=ceilf(a)
For "PTX" %float floor(float a)=floorf(a)
}
__cuintrinsic__ int clock(){}
__intrinsic__ void __syncthreads(){
	aprelive
}
__cuintrinsic__ void __syncthreads(){
	aprelive
}
/
	using meta
	ops=char*[]const["Add","Exch","Min","Max","Inc","Dec","And","Or","Xor"]
	//fus
	tps=int[]const[0x111,0x222,0x111,0x111,0x010,0x010,0x022,0x022,0x022]
	ts=char*[]const["int","u32","f32"]
	emitcode_begin()
	for i=0:8
		op=ops[i]
		for j=0:2
			tag=((tps[i]>>(4*j))&15)
			if !tag:continue
			t=ts[j]
			write-emitcodef('__intrinsic__ ',t,' atomic',op,'(',t,'* a,',t,' b){aprelive}')
	emitcode_end()
__intrinsic__ int atomicSub(int* a,int b){aprelive}
__intrinsic__ u32 atomicSub(u32* a,u32 b){aprelive}
__intrinsic__ int atomicCAS(int* a,int c,int v){aprelive}
__intrinsic__ u32 atomicCAS(u32* a,u32 c,u32 v){aprelive}
__intrinsic__ u64 atomicCAS(u64* a,u64 c,u64 v){aprelive}
__intrinsic__ u64 atomicExch(u64* a,u64 b){aprelive}
__intrinsic__ u64 atomicAdd(u64* a,u64 b){aprelive}
__intrinsic__ u64 atomicSub(u64* a,u64 b){aprelive}
//__intrinsic__ f32 atomicAddf(f32* a,f32 b){aprelive}
__device__ i64 atomicCAS(i64* a,i64 c,i64 v)
	=(i64)atomicCAS((u64*)a,(u64)c,(u64)v)
__device__ i64 atomicExch(i64* a,i64 b)
	=(i64)atomicExch((u64*)a,(u64)b)
__device__ i64 atomicAdd(i64* a,i64 b)
	=(i64)atomicAdd((u64*)a,(u64)b)
__device__ i64 atomicSub(i64* a,i64 b)
	=(i64)atomicSub((u64*)a,(u64)b)
For "PTX" %float atomicAddf(float* a,float b)
	ai=(int*)a
	x=*ai
	for(;;)
		x2=__float_as_int(__int_as_float(x)+b)
		if x2==x:break
		xx=atomicCAS(ai,x,x2)
		if xx==x:break
		x=xx
	return __int_as_float(x)
__cuintrinsic__ u16 __float2half_rn(float x){}
__cuintrinsic__ float __half2float(u16 h){}
For "PTX" %u16 __float2half(float x)=__float2half_rn(x)
For "x86" %u16 __float2half(float f)
	int i=__float_as_int(f);
	int s =  (i >> 16) & 0x00008000;
	int e = ((i >> 23) & 0x000000ff) - (127 - 15);
	int m =   i 	   & 0x007fffff;
	if (e <= 0)
		if (e < -10)
			return 0;
		m = (m | 0x00800000) >> (1 - e);
		if(m&0x00001000): m += 0x00002000;
		return s | (m >> 13);
	else if (e == 0xff - (127 - 15))
		if (m == 0)
			return s | 0x7c00;
		else
			m >>= 13;
			return s | 0x7c00 | m | (m == 0);
	else
		if (m &  0x00001000)
			m += 0x00002000;
			if (m & 0x00800000)
				m =  0;
				e += 1;
		if (e > 30)
			return s | 0x7c00;
		return s | (e << 10) | (m >> 13);

For "Cx86" %u16 __float2half(float f)
	int i=__float_as_int(f);
	int s =  (i >> 16) & 0x00008000;
	int e = ((i >> 23) & 0x000000ff) - (127 - 15);
	int m =   i 	   & 0x007fffff;
	if (e <= 0)
		if (e < -10)
			return 0;
		m = (m | 0x00800000) >> (1 - e);
		if(m&0x00001000): m += 0x00002000;
		return s | (m >> 13);
	else if (e == 0xff - (127 - 15))
		if (m == 0)
			return s | 0x7c00;
		else
			m >>= 13;
			return s | 0x7c00 | m | (m == 0);
	else
		if (m &  0x00001000)
			m += 0x00002000;
			if (m & 0x00800000)
				m =  0;
				e += 1;
		if (e > 30)
			return s | 0x7c00;
		return s | (e << 10) | (m >> 13);

//todo: half2float

For "PTX" %void sincos(float th,float* ps,float* pc)
	__asm__("{float __spap_sin,__spap_cos;sincos(",th,",&__spap_sin,&__spap_cos);","@prelive")
	*ps=__asm__("@return",meta.typeid(float),"=__spap_sin")
	*pc=__asm__("@return",meta.typeid(float),"=__spap_cos")
	__asm__("}","@prelive")

For "x86" %void sincos(float th,float* ps,float* pc)
	*ps=sin(th)
	*pc=cos(th)

For "Cx86" %void sincos(float th,float* ps,float* pc)
	*ps=sin(th)
	*pc=cos(th)

void cudevBigLoop()
	using function_global,meta
	ncore=(int()()spapGetGpuApi("cudaGetCoreCount"))()
	n_true_thread=ncore*1024
	__asm__("@@param maker")
	defglobal iptr __thread_size
	defglobal void* __kernel
	defglobal void* __param
	defglobal iptr __szparam
	spapLaunch(__kernel,n_true_thread,__param,__szparam)
	spawn 1
		defglobal iptr __thread_rank
		rk0=__asm__("@return",meta.typeid(iptr),"=blockIdx.x*blockDim.x+threadIdx.x")
		sz=__thread_size
		for(i=rk0;i<sz;i+=n_true_thread)
			__thread_rank=i
			__asm__("@@kernel body")
__cuintrinsic__ float pow(float x,int p){}
