//todo: script-user-program interaction system
const
	t0_unknown=-1,
	t0_i8=0,
	t0_u8=1,
	t0_i16=2,
	t0_u16=3,
	t0_i32=4,
	t0_u32=5,
	t0_i64=6,
	t0_u64=7,
	t0_f32=8,
	t0_f64=9,
	t0_void=10,
	t0_type=11,//doesn't allow derivative types
	t0_typename=t0_type,
	t0_unknownref=13,
	t0_unknowncref=14,
	//BE only
	t0_madummy=15,
	t0_reserved=16,
	t0_logicdummy=17,
	//////////
	t0_iptr=t0_i32
	t0_end=-2
	gt_line=0
	gt_functemp=1
	gt_clstemp=2
	gt_statementish=gt_functemp
	gt_toch=3
	gt_block=4
	gtf_mode=7
	gtf_stripindent=8
	gtf_addlineinfo=16
	gtf_discard=32
	gtf_noskip_for_discard=64
	gtf_noncode=128
	gtf_noskip_discard=gtf_discard|gtf_noskip_for_discard
	gtf_code=gtf_stripindent|gtf_addlineinfo
	tranid_decl=0//does nothing when id
	tranid_stat=1
	tranid_expr=2
	tranid_builtin_only=3
	decl_normal=0
	kw_struct=11
	kw_union=12
	kw_static=13
	kw_class=27
	ssaopt_build=1
	ssaopt_flatten=2
	ssaopt_keeppure=4
struct ckfd
struct ccd
struct cvar
struct cdecl
struct cstruct
struct cinitializer
	void* pdata
	void* pdatac
	iptr t
	//still more
struct clisp(T)
	int __is_lisp
		get()=1
	clisp(T)* x
	union
		clisp(T)* tail
		clisp(T)* w
	T a
	%__iter__()=this
	%__next__(clisp(T)* a)=a.x
	%__data__(clisp(T)* a)=a.a
struct clist(T)
	T* d
	iptr n,sz
	int mymode
	T[2] d0
	back()=.d+(.n-1)
	%__iter__()=0
	%__valid__(int a)=a<.n
	%__next__(int a)=a+1
	%__data__(int a)=.d[a]
struct chashentry
	chashentry* x
	iptr tag
struct csymbol:chashentry
	char* s0
	char* s
		get()=this?.s0:"<anonymous>"
typedef csymbol* tsymbol
typedef tsymbol identifier
typedef iptr ttype
struct cscope
	clisp(cdecl*)* members
	cstruct* sd
	int usetime
	void* innervs
struct cany_str{int[2]a;};
struct ccns
	ttype t
	union
		i8 ci8;u8 cu8;
		i16 ci16;u16 cu16;
		i32 ci32;u32 cu32;
		f32 cf32;
		iptr ciptr;ttype ctype;cany_str cany;
	f64 cf64{&%get()=f64*&.ci32;%set(f64 b)*f64*&.ci32=b};
	i64 ci64{&%get()=i64*&.ci32;%set(i64 b)*i64*&.ci32=b};
	u64 cu64{&%get()=u64*&.ci32;%set(u64 b)*u64*&.ci32=b};
typedef clisp(ccd*)* ccode
cons(a)
	typedef typeof(a) T
	p=(clisp(T)*)poolalloc2(sizeof(clisp(T)))
	p.a=a
	p.tail=p
	p.x=null
	return p
struct cindef
	const
		string=0
		fptr=1
		data=2
		hack=3//currently BSGP BE only
	int what
	union
		struct
			char* str
			iptr strsz
		void* pf
		cinitializer* pinit
		struct
			u32 hackwhat
			iptr hackd
struct cmember
	int what
	ttype t
	tsymbol id
	iptr ofs
	void* pt
struct copr
	const
		cns=0
		var=1
		indef=2
		local=3
		bss=4
	int what
	union
		cvar* v
		ccns c
		cindef idef
		cmember* pm
with copr{static
	copr V(cvar* v)
		result.what=copr.var
		result.v=v
	copr L(cvar* v)
		result.what=copr.local
		result.v=v
	copr I(iptr i)
		result.what=copr.cns
		result.c.t=t0_iptr
		result.c.ciptr=i
}
struct cexpres
	const
		cns=0
		var=1
		val=2
		indef=3
		hook=4
		dhook=5
		bss=6
		castdecl=7
		casted=8
		invalid=-1
	int what
	ttype t
	union
		cvar *v
		ccns c
		cindef idef
		struct
			iptr[4] hdata
			void()(cexpres*) onrval
			//should set expres to return value
			void()(cexpres*,cexpres*) onlval
			char* rverr,lverr
		struct
			iptr[4] ddata
			void()(cexpres*,ttype) ondecl
			tsymbol did
			cscope* dsc
			char* dpos
		cmember* pm
	ccode code
	clear()
		.code=null
	makedecl(cscope* sc,tsymbol id,void()(cexpres*,ttype) ondecl,char* epos)
		.clear()
		.what=dhook
		.t=t0_unknown
		.ondecl=ondecl
		.did=id
		.dsc=sc
		.dpos=epos
	declas(ttype t)
		/*assert(.what==dhook)
		assert(t!=t0_unknown&&t!=t0_unknownref&&t!=t0_unknowncref)*/
		.ondecl(this,t)
	makehook(void()(cexpres*) r,void()(cexpres*,cexpres*) l)
		.what=hook
		.onrval=r;.onlval=l
	makehook(void()(cexpres*) r,char* l)
		.what=hook
		.onrval=r;.onlval=null
		.lverr=l
	makehook(char* r,void()(cexpres*,cexpres*) l)
		.what=hook
		.onrval=null;.onlval=l
		.rverr=r
	makehook(char* r,char* l)
		.what=hook
		.onrval=null;.onlval=null
		.rverr=r;.lverr=l
struct cfunction
struct cdecl:chashentry
	const
		variable=0
		metaf=1
		gotolabel=2
		constant=3
		tstruct=4
		typealias=5
		metaid=6
		member=7
		property=9
		constant_indef=10
	int what
	tsymbol id
	char* desc
	char* declpos
	cscope* where
	void* p
	cdecl* ix,mfhack
struct cfunction
struct cgenerator
	u32 tar,what
	iptr()(ccd*) g
struct cmetaid
	const
		metaid_noexpr=1
		metaid_ccnv=2
	void()(iptr) hook
	iptr a
	int flags
struct ctarget
struct cmetaf
	tsymbol ishack//should be 0 for normal cmetaf
	tsymbol id
	cscope* where
	char* epos
	cdecl* pdecl
	cfunction* f
	ctarget* spectarget
	cmetaf*()(cmetaf*,clist(cexpres*)*) onmatch
	cexpres()(cmetaf*,clist(cexpres*)*) onparse
	//ongen is per-target, takes instruction to gen
	clisp(cgenerator)* ongen
	cgenerator ongen_cache
	cmetaf* x
struct ccd
	const
		opjmp=0
		opjcc=1
		oplbl=2
		ctag_ccnot=1
		ctag_short=8
	union
		cmetaf* f
		iptr op
	union
		cvar* a
		ccd* tar
		iptr lbaddr_x86
	union
		clist(copr)* b
		cvar* cc
	int _tags
	ccode ma_ilist
	int clone_time
	ccd* clone
	char* sbegin
	//////////////
	ckfd* pblock//expandable
	cvar* sa,bkren//expandable
	//more later
struct cparameter
	ttype t
	tsymbol id
	int pcnv
struct clexscope
	const
		lnormal=0
		lfunction=1
		lstruct=2
	int what
	cscope* sc
	clisp(cscope*)* usings
	cstruct* sd
struct cfunction
	const
		freturnref=2
		ftakeva=4
		fismethod=8
		fistemplate=16
		fisvirtual=32
		fisctc=64
		fisimposter=128
		fisvatemplate=256
		f_exactmatch=ftakeva
		cv_cdecl=0
		cv_stdcall=1
		cv_fastcall=2
		//>= inline means non-push
		cv_inline=3
		cv_intrinsic=4
	ttype t
	tsymbol id
	clist(cparameter)* as
	clist(cvar*)* avs
	cmetaf* pmf
	int flags
	int ccnv
	int inited
	int ismethod
		%get()=!!(.flags&fismethod)
	int istemplate
		%get()=!!(.flags&fistemplate)
	//for imposter
	cfunction* f0
	cfunction* root
		get()
			pf0=this
			while pf0.flags&cfunction.fisimposter:
				pf0=pf0.f0
			return pf0
	//for normal function
	clexscope* sc
	ccode code
	cvar* vret,vthis
	ccd* lret,eoc
	ccode eocpos
	iptr[2] pbin
	//for virtual
	void* powner
	iptr vfid
	//for template
	void* ctx
	int defversion
	//BE
	int alive
	//more later...
struct ctype
	const
		pointer=0
		array=1
		func=2
		tstruct=3
		strptr=4
		//not-actually-used type
		refargu=6
	int what
	ttype t0
	ttype pt
	ttype ref
	tsymbol castid
	union
		struct
			iptr sz
			iptr asz
		cfunction* vf
		cstruct* sd
struct ctarget
	u32 id
	char* name
	int supportclass
	int needalign
	int needdepend
	//more following
struct ccontext
struct cvar
	ttype t
	tsymbol vid
	//more following
struct cstruct
	cscope* sc
	tsymbol id
	int mode//kw_blah
	iptr ofs
	iptr sz,alg
	int complete
	int forcealg
	ttype stype
	cstruct* psuper
	cdecl* pdecl
	//class
	int isclass
	clist(cfunction*)* vfs
	cinitializer* vftab
	//more following
struct coperator
	tsymbol id;int pr
	int mayprefix
struct clexdata
	int cnt
	int isbra
	union
		tsymbol id
		ccns c
		struct
			ttype type
			cindef idef
		struct
			void* pdecl "declarable feed"
			int dotted
		struct coperator
			tsymbol id;int pr
			int mayprefix
		coperator op
		cexpres efeed
		cmetaf* ffeed
struct cminictx
	int lexfeedtop
	int lex
	clexdata d
	char* epos
	char* feed
	int ch
	char* curfname
	int deltaline
struct cproperty
	tsymbol id
	ttype t
	int mode
	cmetaf* fget,fset
	cstruct* owner
	char* epos
//control flow node
struct ckfd
	const
		enormal=0
		ejcc=1
		eend=2
	ccode code
	int ehow
	cvar* cc
	int ccnot
	char* jsbegin,lbepos
	ccd* blabel
	clist(ckfd*) succ,pred
	clist(int) succid//whichpred
	////////////////
	int reached,instack,succloop
	clisp(ckfd*)* dfront
	ckfd* dom
	int poed//expandable
	clisp(ccd*)* phi
	clisp(ckfd*)* chdom
	//more later
struct cbsgpccd
	ccode creq
	ccode creqe
	clist(cvar*)* lin
	int lbaddr
	int lsarv
struct cconstindef
	ttype t
	cindef idef
struct cunit
	cdecl* st
	clexscope* lsc
	char* fname
	char* txt0
	ccontext* state
	int stage
	clist(cscope*)* alsouses
	int isuser
struct cfile
	char* name
	char* text
	iptr tsz
	clist(iptr)* lines
//ctc interface
import "ulprt.dll"
	int gotstr()
	char* wantstr()
	tsymbol wantid()
	int got(int a)
	int want(int a)
	void expect(int a)
	void skip(int a)
	void nextlex()
	void nextch()
	void unlex(int a)
	cdecl* declare_metaid(tsymbol id,void()(iptr) hook,iptr a)
	void auto_uses_this()
	cfunction* handyfunc(ttype t)
	void* compile(cfunction*)
	int validateid(char*)
	int isidhead(int)
	int isidbody(int)
	tsymbol getid(char*)
	ttype atype()
	void feedexpr(cexpres* pe)
	void feeddecl(cdecl* pd)
	void feedtype(ttype t)
	void feedstat(ccode code)
	void feedfunc(cmetaf* pmf)
	void feedid(tsymbol id)
	void declreturn(cdecl* pd)
	cexpres makeeri(iptr c)
	cexpres makeervar(cvar* v)
	cexpres makeerstr(char* s0)
	void makecnsiptr(cexpres* e,iptr c)
	char* gettext(int flags,int ch)
	char* gettext(int flags) "gettext2"
	char* getlineinfo()
	void emitcode(char *s)
	void emitcodef(char *fmt,*)
	void emitlineinfo()
	void emitcode_clear()
	void emitcode_flush()
	iptr cnsexpr()
	clist(cparameter)* prototype_1() "prototype"
	cexpres* castto(cexpres* e,ttype t)
	void tranid(int mode)
	cexpres atom_pd(cexpres* pe,char* rrerr,cdecl* pd)
	cdecl* wantdeclarable()
	cexpres assexpr()
	cexpres call(tsymbol id,clist(cexpres*)* ps)
	cexpres callpf0(cmetaf* pf0,clist(cexpres*)* ps)
	cexpres call_str(char* s,clist(cexpres*)* ps)
	cexpres call(cmetaf* pmf,clist(cexpres*)* ps)"callraw"
	void ctc_verrorf(int fatal,char* fmt,void* v)
	void* poolalloc(iptr sz)
	void* poolalloc2(iptr sz)
	int isptr(iptr p) "_isptr"
	int tis(ttype t,int w)"wrap_tis"
	int tisprimitive(ttype t)"wrap_tisprimitive"
	int tmatchvoidp(iptr t)"wrap_tmatchvoidp"
	int tiscomplicated(iptr t)"wrap_tiscomplicated"
	int tisclass(ttype t)"wrap_tisclass"
	int tisnakedclass(ttype t)"wrap_tisnakedclass"
	int tisiptrcastable(iptr t)"wrap_tisiptrcastable"
	int tisint(ttype t)"wrap_tisint"
	int tisunsigned(ttype t)"wrap_tisunsigned"
	int tissigned(ttype t)"wrap_tissigned"
	int tisfloat(ttype t)"wrap_tisfloat"
	char* getcmdlineoption(char*)
	cdecl* findmember(ttype,tsymbol)
	void evalto(cexpres*,void*)
	void labslice(cexpres& e0,cexpres& e1,cexpres& e2)
	iptr _sizeof(ttype t)
	iptr alignof(ttype t)
	int __is_user_specified()
	tsymbol __tok_id()
	coperator& __tok_op()
	clexdata& __token()
	void findunit(char* ret,char* s)
	void adderrfile(char* fn2,char* ret,iptr sz)
	cdecl* declare(int what,tsymbol id,void* p)
	cdecl* declare(int what,tsymbol id,void* p,cscope* sc)"declareat"
	int undeclare(cdecl*)
	cdecl* findname(cscope* sc,tsymbol id)
	cvar* makevar(ttype)
	ckfd* makekfd()
	ccontext* context_save()
	void context_snapto(ccontext* ct0)
	void context_restore(ccontext* ct0)
	ccontext* context_snapshot()
	void context_push(ccontext* ct)
	void context_pop()
	cdecl* decl()
	cfunction* findmethod(ttype t,tsymbol id,ttype* as)
	void appendfunc(cfunction* pf)
	void initfunc(cfunction* pf)
	void* decldata(ttype t,tsymbol id)
	ttype makearraytype(ttype t,iptr sz)
	ttype makeptrtype(ttype t)
	ttype makereftype(ttype t)
	ttype makefunctype(int ccnv,ttype t,clist(cparameter)* as,int isva)
	ttype makefunctype(cfunction* pf) "makefunctypef"
	u32 hashstr(char* s)
	cexpres txtexpr(char* s)
	cexpres* vaargtran(cexpres* pe,int isintrinsic)
	cexpres dotsth(cexpres* pe0,tsymbol id)
	cmetaf* fonmatch(cmetaf* f,clist(cexpres*)* ps)
	ccode statement()
	ccode statement_noscope()
	void strptr_scan(ccode code,ccode& pinit,ccode& pdone)
	int get_curunit()
	char** output_filename()
	cdecl* decl(int mode) "olddecl"
	int* get_ccompat()
	ttype effstruct(ttype t)
	char* geteposstr(char* epos)
	char* geteposstr_r(char* epos)
	cmetaf* funcfromname(cmetaf* pmf,int& isamb)
	//ccode lambda_statement(ccode()(ccode,ccode,int) tran)
	cmetaf* makeintrinsic()
	ccode makema(cmetaf* f,clisp(cvar*)* vs,copr* b,int n) "makema_export"
	ccd* makeccd(cmetaf* f,cvar* a,copr* b,int n) "makeccd_export"
	void appendfunc(cfunction* pf,ccode code,char* epos0) "appendfunc_export"
	void push_localscope(cstruct* sd) "push_localscope_sd"
	void push_localscope()
	void pop_localscope()
	cmetaf* makemetaf(ttype t,cparameter* as,int an,int ccnv)
	cexpres forcevar(cexpres* pe)
	void applydata(cdecl* pd)
	ttype atype0()
	ttype typemodifiers_new(ttype t0,int* isa,cexpres* asz)
	void emitcode_expr(cexpres* a)
	void emitcode_str(char* s)
	int findinsideunit(char* s,char** name,char** text)
	void addongen(cmetaf* pmf,u32 tar,u32 what,iptr()(ccd*) g)
	ccontext* makefilectx(cstruct* host,char* txt0)
	int minictx_get(cminictx* pmc)
	int minictx_set(cminictx* pmc)
	void makelogic(cexpres* pe)
	ccode makeif(cexpres* pe,ccode clt,ccode clf)
	ccode makeswitch(cvar* v,ccd* ld,void* cs0)
	ccode makefor(ccode st,cexpres* cd,ccode lp,ccode body,ccd* lbreak,ccd* lcont)
	ccd* makelabel()
	ccd* makejmp(ccd* tar)
	ccd* makelogic_internal(cexpres* pe,cvar* v0)
	ccns* ovalue(copr* po)
	char[260] token_name(int s)
	ccode with_expr(cexpres* pe0)
	void withpop()
	cexpres makeertype(ttype t)
	int addusing(clexscope* lsc,ttype t)
	ccode perform_tra0(ccode cd0)
	ccode tranglobals(ccode code)
	void backend_begin(ccode code)
	ccode backend_end(ccode()(ccode) reltran)
	int* get_clone_to()
	void ssastdopt(int flag) "_ssastdopt"
	void phielim() "phielim"
	ccode dupcode(ccode code)
	ccode clonecode(ccode code)
	cexpres opr2res(copr* o)
	ccode getmalist(ccd* pi)
	char* get_curunit_dir(char* buf,int n)
	void edmessage(char* s)
	int begin_permanent()
	void end_permanent(int em0)
	void collapse_if_auto(cexpres* pe)
	ttype roottype__auto__(ttype tb)
	copr rvalue(cexpres* er)
	void lvalue(cexpres* er,cexpres* b)
	void castdecl_L(cexpres* er)
	void setnop(ccd* pi)
	void rematerialize(ccd*()(cvar*) isremat)
	void release_compiler_pool()
	void setup_compiler(int olevel,int wlevel)
	void parse_everything()
	cunit* addunit_find(char* s,tsymbol id)
static ctc{
typedef cstruct Struct
import "ulprt.dll"
	void __ctc_dllinit()
	cexpres fonlea(cmetaf* pmf)
	cstruct* get_curstruct()
	cmetaf* get_curfunc()
	cfunction* get_becurfunc()
	ctarget* get_curtarget()
	void set_curtarget(ctarget*)
	ctarget* get_spectarget()
	void set_spectarget(ctarget*)
	ctarget* get_target_native()
	ctarget* get_target_ulp()
	void()() get_finhook()
	void set_finhook(void()())
	void()(void*,cfunction*,char*) get_onfuncbody()
	void set_onfuncbody(void()(void*,cfunction*,char*) a)
	void* get_onfuncbody_param()
	void set_onfuncbody_param(void* a)
	int get_curversion()
	set_curversion(int a)
	int get_curlex()
	int get_curch()
	int get_idmode()
	clist(cfile*)* get_files()
	cunit* get_curunit2()
	cexpres* get_macroobj()
	void set_macroobj(cexpres* a)
	char* getepos()
	void setepos(char* a)
	clist(clexscope*)* get_lexs()
	int get_wlevel()
	void set_wlevel(int a)
	char* get___FILE__()
	void set___FILE__(char* a)
	int get___LINE__()
	void set___LINE__(int a)
	ccns* get_ret_eval()
	void()() get_lexhook()
	void set_lexhook(void()() a)
	char* get_sourcedir()
	char* get_startdir()
	char* get_defaultdir()
	int* get_vstudio()
	clist(ckfd*)* get_bcode()
	int get_debug()
	void set_debug(int)
	void*& state(char*)
	cbsgpccd* get_bsgp(ccd*)
	int get_regid(ccd*)
	u32 getppti(ccd*,u32)
	u32 getpptf(cmetaf*,u32)
	int get_regidv(cvar*)
	int get_extraiv(cvar*)
	void set_extraiv(cvar*,int)
	ccd* get_pdef(cvar*)
	void set_pdef(cvar*,ccd*)
	clisp(ccd*)* get_users(cvar*)
	void clist_ckfd_resize(void*,int)
	Struct* get_Struct(ttype)
	ttype Struct_get_type(Struct*)
	Struct* active_Struct()
	clisp(cdecl*)* get_first_member(cstruct*)
	void*& get_func_estate(cfunction*,u32)
cstruct* curstruct
	%cstruct* get()=get_curstruct()
cmetaf* curfunc
	%cmetaf* get()=get_curfunc()
cfunction* be_curfunc
	%cfunction* get()=get_becurfunc()
cfunction* bsgp_curfunc
	%cfunction* get()=.state("BSGP-curfunc")
ccd* bsgp_curspawn
	%ccd* get()=.state("BSGP-curspawn")
ctarget* curtarget
	%ctarget* get()=get_curtarget()
	%void set(ctarget* a)set_curtarget(a)
ctarget* spectarget
	%ctarget* get()=get_spectarget()
	%void set(ctarget* a)set_spectarget(a)
ctarget* target_native
	%ctarget* get()=get_target_native()
ctarget* target_ulp
	%ctarget* get()=get_target_ulp()
void()() finhook
	%void()() get()=get_finhook()
	%set(void()() a)set_finhook(a)
void()(void*,cfunction*,char*) onfuncbody
	%void()(void*,cfunction*,char*) get()=get_onfuncbody()
	%set(void()(void*,cfunction*,char*) a)set_onfuncbody(a)
void* onfuncbody_param
	%void* get()=get_onfuncbody_param()
	%void set(void* a)set_onfuncbody_param(a)
int curversion
	%int get()=get_curversion()
	%set(int a)set_curversion(a)
int lex
	%int get()=get_curlex()
int ch
	%int get()=get_curch()
clexdata* d
	%get()=&__token()
int idmode
	%int get()=get_idmode()
clist(cfile*)* files
	%clist(cfile*)* get()=get_files()
cunit* curunit
	%cunit* get()=get_curunit2()
int curunitid
	%int get()=get_curunit()
int ccompat
	%int get()=*get_ccompat()
	%set(int a)*get_ccompat()=a
cexpres* macroobj
	%cexpres* get()=get_macroobj()
	%set(cexpres* a)set_macroobj(a)
char* epos
	%char* get()=getepos()
	%set(char* a)setepos(a)
char* eposstr
	%char* get()=geteposstr(.epos)
clist(clexscope*)* lexs
	%clist(clexscope*)* get()=get_lexs()
cscope* curscope
	%get()=(*.lexs.back()).sc
int wlevel
	%int get()=get_wlevel()
	%set(int a)set_wlevel(a)
%int W(int wl)=.wlevel>=wl
char* __FILE__
	%char* get()=get___FILE__()
	%set(char* a)set___FILE__(a)
int __LINE__
	%int get()=get___LINE__()
	%set(int a)set___LINE__(a)
ccns* ret_eval
	%ccns* get()=get_ret_eval()
void()() lexhook
	%void()() get()=get_lexhook()
	%set(void()() a)set_lexhook(a)
char* source_dir
	%char* get()=get_sourcedir()
char* start_dir
	%char* get()=get_startdir()
char* default_dir
	%char* get()=get_defaultdir()
int visualstudio
	%int get()=*get_vstudio()
	%void set(int a)*get_vstudio()=a
clist(ckfd*)* bcode
	%clist(ckfd*)* get()=get_bcode()
int debug_enabled//-g
	%int get()=get_debug()
	%set(int a)set_debug(a)
int clone_to
	%&get()=get_clone_to()
	%void set(int a)*get_clone_to()=a
}
using ctc
with ccd
	cbsgpccd* bsgp
		%cbsgpccd* get()=get_bsgp(this)
	int regid
		%int get()=get_regid(this)
	%u32 property(u32 ppt)=getppti(this,ppt)
	%u32 property(char* s)
		return .property(hashstr(s))
with cmetaf
	%u32 property(u32 ppt)=getpptf(this,ppt)
	%u32 property(char* s)
		return .property(hashstr(s))
with cvar
	int regid
		%int get()=get_regidv(this)
	int extrai
		%int get()=get_extraiv(this)
		%void set(int a)set_extraiv(this,a)
	ccd* pdef
		%ccd* get()=get_pdef(this)
		%void set(ccd* pdef2)set_pdef(this,pdef2)
	clisp(ccd*)* users
		%clisp(ccd*)* get()=get_users(this)
with clist(ckfd*)
	%resize(iptr sz)clist_ckfd_resize(this,sz)
with clist(iptr)
	%resize(iptr sz)clist_ckfd_resize(this,sz)
with Struct
	ttype ptrtype
		%get()=makeptrtype(.stype)
	ttype thistype
		%get()=.isclass?makeptrtype(((ctype*)(.stype)).t0):.ptrtype
	%clisp(cdecl*)* __iter__()=get_first_member(this)
	inline __next__(clisp(cdecl*)* a)=a.x
	inline __data__(clisp(cdecl*)* a)=a.a
	inline ttype gettype()=.stype
	%cdecl* operator[](char* s)=findmember(.gettype(),getid(s))
	%cdecl* operator[](tsymbol id)=findmember(.gettype(),id)
inline int tispointer(ttype t)=tis(t,ctype.pointer)
inline int tisstruct(ttype t)=tis(t,ctype.tstruct)
inline int thasmember(ttype t)=effstruct(t)!=t0_unknown
with $$__builtin_scope
	inline operator(char**)(tsymbol id)=&id.s0
looklex()=ctc.lex
ttype* prototype()
	pa=prototype_1()
	ret=new[pa.n+1]ttype
	for i=0:pa.n-1
		ret[i]=pa.d[i].t
	ret[pa.n]=t0_end
	return ret
%void emitcode_begin()emitcode_clear()
%void emitcode_end()emitcode_flush()
%cexpres makeerv(cvar* v)[=]makeervar(v)
with cfunction
	void*& estate(u32 tag)=get_func_estate(this,tag)
	void*& estate(char* s)
		return &.estate(hashstr(s))
with ctc
	%__init__()__ctc_dllinit()
