uses emmintrin
/
	*(int*)meta.state('global.spap_enabled')=1
	meta.auto_uses_this()
static detail
using detail
struct CSPAPProcessor
	u32 brand
	int ver
	iptr id

import "spaprt.dll"
	void* spapClassAlloc(iptr sz)
	void spapClassFree(void* p)
	void* spapMalloc(iptr sz)
	void spapFree(void* p)
	void* spapRealloc(void* p,iptr sz2)
	void spapZero(void* p,iptr sz)
	void spapRequestPrivateHeap()
	void spapReleasePrivateHeap()
	iptr spapPeakMemoryUsage()
	u32 spapHash(void* p,int len)
	//////////////////////////////////
	int spapGetProcessorCount()
	CSPAPProcessor* spapGetProcessor(int id)
	int spapRunAt(int thid,void()(void*) func,void* param)
	int spapWaitFor(int thid)
	void spapWaitForAll()
	int spapDetectTarget(u32 s)
	void spapResetProcessor()
	int spapSetGlobalOption(char* s)
	int spapSetLocalOption(char* s)
	void spapPushLocalOptionSet()
	void spapPopLocalOptionSet()
	//////////////////////////////////
	void spapSetGlobalTask(void* a)
	void* spapGetGlobalTask()
	int spapAcquireGlobalTask()
	void spapReleaseGlobalTask(int doexit)
	void spapBeginSubTask()
	void spapEndSubTask()
	//////////////////////////////////
	void spapLaunch(void* pkrnl,iptr n,void* pp,iptr szp)
	int spapFinish()
	//////////////////////////////////
	void* spapAllocd(iptr sz)
	void spapFreed(void* p)
	void* spapReallocd(void* p,iptr sz)
	int spapCpyh2d(void* a,void* b,iptr sz)
	int spapCpyd2h(void* a,void* b,iptr sz)
	int spapCpyd2d(void* a,void* b,iptr sz)
	int spapGetCurrentCoreId()

//min, max
/
	using meta
	emitcode_begin()
	for i=t0_i8:t0_u64
		tn=dumptype(i)
		write-emitcodef("__intrinsic__ ",tn," min(",tn," a,",tn," b);")
		write-emitcodef("For 'x86' inline ",tn," min(",tn," a,",tn," b)=system.min(a,b);")
		write-emitcodef("For 'Cx86' inline ",tn," min(",tn," a,",tn," b)=system.min(a,b);")
		write-emitcodef("__intrinsic__ ",tn," max(",tn," a,",tn," b);")
		write-emitcodef("For 'x86' inline ",tn," max(",tn," a,",tn," b)=system.max(a,b);")
		write-emitcodef("For 'Cx86' inline ",tn," max(",tn," a,",tn," b)=system.max(a,b);")
	emitcode_end()
//vectors
static detail{
vtmaker=/new string
genvec(char* tname,int isf,int iss)
	using meta
	//generate vector arithmatic
	char[128]ebuf
	write-sprintf(ebuf;"sizeof(",tname,")")
	eval(ebuf,t0_iptr,&iptr szt)
	for dim=2:4
		if szt>=8&&dim>2:break
		write-sprintf(char[16] buf;tname,dim)
		write-emitcodef(;"struct ",buf,"{",tname," ")
		for i=0:dim-1
			if i:emitcode(",")
			write-emitcodef(;"xyzw"[i])
		write-emitcodef(;";typedef ",tname," Telement")
		write-emitcodef(;";const{ndim=",dim,"}")
		if dim!=3:
			write-emitcodef(;";int __is_vector{get()=1;}")
		else
			write-emitcodef(;";int __is_3vec{get()=1;}")
		write-emitcodef(;";int __cudatype{get()=1;};")
		write-emitcodef(;"/{meta.curstruct.cbetags|=meta.cstruct.CBE_CUDASYS}")
		write-emitcodef(;";%&operator[](int d)=(",tname,"*)this+d;")
		sztv=szt*dim
		if (sztv&15)==0:
			write-emitcodef(;"__align__(16);")
		else if (sztv&7)==0:
			write-emitcodef(;"__align__(8);")
		write-emitcodef(;";%&operator=(",tname,"*a){")
		for i=0:dim-1
			write-emitcodef(;"((",tname,"*)this)[",i,"]=a[",i,"];")
		write-emitcodef(;"=this;}};")
		if iss==2:goto noop
		for i=0:7
			if i>3&&isf:break
			op="+-*/%&|^"[i]
			write-emitcodef(;"%",buf," operator",op,"(",buf," aa,",buf," bb){a=",tname,"*&aa;b=",tname,"*&bb;")
			for j=0:dim-1
				write-emitcodef(;"((",tname,"*)result)[",j,"]=a[",j,"]",op,"b[",j,"];")
			emitcode("}")
			write-emitcodef(;";%&operator",op,"=(",buf,"& a,",buf," bb){b=",tname,"*&bb;")
			for j=0:dim-1
				write-emitcodef(;"(",tname,"*&a)[",j,"]",op,"=b[",j,"];")
			emitcode("=&a;}")
		write-emitcodef(;"%",buf," min(",buf," aa,",buf," bb){a=",tname,"*&aa;b=",tname,"*&bb;")
		for j=0:dim-1
			write-emitcodef(;"((",tname,"*)result)[",j,"]=min(a[",j,"],b[",j,"]);")
		emitcode("}")
		write-emitcodef(;"%",buf," max(",buf," aa,",buf," bb){a=",tname,"*&aa;b=",tname,"*&bb;")
		for j=0:dim-1
			write-emitcodef(;"((",tname,"*)result)[",j,"]=max(a[",j,"],b[",j,"]);")
		emitcode("}")
		write-emitcodef(;"%dot(",buf," aa,",buf," bb){a=",tname,"*&aa;b=",tname,"*&bb;=")
		for i=0:dim-1
			if i:emitcode("+")
			write-emitcodef(;"a[",i,"]*b[",i,"]")
		emitcode("};")
		write-emitcodef(;"%",buf," operator-(",buf," aa){a=",tname,"*&aa;")
		for i=0:dim-1
			write-emitcodef(;"((",tname,"*)result)[",i,"]=-a[",i,"];")
		emitcode("};")
		write-emitcodef(;"%",buf," operator*(",buf," a,",tname," bb){b=bb;")
		for i=0:dim-1
			write-emitcodef(;"((",tname,"*)result)[",i,"]=b*a[",i,"];")
		emitcode("};")
		if !iss:
			write-emitcodef(;"%operator*(",tname," b,",buf," a)=a*b;")
			write-emitcodef(;"%&operator*=(",buf," a,",tname," b){a=a*b;=&a;}")
		if isf:
			write-emitcodef(;"%operator/(",buf," a,",tname," b)=a*((",tname,"(1))/b);")
			write-emitcodef(;"%&operator/=(",buf," a,",tname," b){a=a/b;=&a;}")
			write-emitcodef(;"%sqr(",buf," a)=dot(a,a);")
			write-emitcodef(;"%length(",buf," a)=sqrt(sqr(a));")
			write-emitcodef(;"%unify(",buf," a)=a*rsqrt(sqr(a));")
			write-emitcodef(;"%normalize(",buf," a)=unify(a);")
		write-emitcodef(;"%",buf," operator(",buf,")(",tname,"*a)*result=a;")
		:noop
		write-emitcodef(;"%",buf," make_",buf,"(")
		for i=0:dim-1
			if i:emitcode(",")
			write-emitcodef(;tname," ",char('a'+i))
		emitcode("){")
		for i=0:dim-1
			write-emitcodef(;"((",tname,"*)result)[",i,"]=",tname," ",char('a'+i),";")
		emitcode("}")
		write-strappendf(.vtmaker;'Elif (T==',tname,')&(n==',dim,'):{typedef ',tname,dim,' type;}')
}
struct half
	u16 x
typedef u64 ulong
typedef u32 uint
typedef u16 ushort
typedef u8 uchar
/
	meta.emitcode_clear()
	genvec("float",1,0)
	genvec("double",1,0)
	genvec("half",1,2)
	genvec("int",0,0)
	genvec("uint",0,0)
	genvec("long",0,0)
	genvec("ulong",0,0)
	genvec("ushort",0,1)
	genvec("uchar",0,1)
	genvec("short",0,1)
	genvec("char",0,1)
	write-meta.emitcodef("struct VectorType(T,const n){If 0:{}",detail.vtmaker,
		"Else{/write-meta.errorf('cannot create vector ',meta.dumptype(meta.typeid(T)),'x',n);}const{typeid=meta.typeid(type);}};")
	meta.emitcode_flush()

with detail{
inline __m128 x86makevec(const tid,......)
	//use the set intrinsics...?
	using meta
	typedef typefromiptr(tid) T0
	typedef T0.Telement T
	const
		n=T0.ndim
	If (n!=2)&(n!=4)|(n!=va_count):
		/write-meta.errorf("panic: weird vector dimension ",n," in x86makevec")
	If (T!=f32)&(T!=f64):
		If sizeof(T)==1:
			w=(u32)(u8)va_arg(0)+((u32)(u8)va_arg(1)<<8)
			If n>2:
				w+=((u32)(u8)va_arg(2)<<16)+((u32)(u8)va_arg(3)<<24)
			return (__m128)(int)w
		Elif sizeof(T)==2:
			w=(u32)(u16)va_arg(0)+((u32)(u16)va_arg(1)<<16)
			If n>2:
				x=(u32)(u16)va_arg(2)+((u32)(u16)va_arg(3)<<16)
				a=_mm_movelh_ps((__m128)(int)w,(__m128)(int)x)
				b=_mm_setzero_ps()
				return _mm_shuffle_ps(a,b,0x88);
			Else
				return (__m128)(int)w
		Elif sizeof(T)==4:
			w=(int)va_arg(0)
			x=(int)va_arg(1)
			a=_mm_movelh_ps((__m128)w,(__m128)x)
			If n>2:
				y=(int)va_arg(2)
				z=(int)va_arg(3)
				b=_mm_movelh_ps((__m128)y,(__m128)z)
			Else
				b=_mm_setzero_ps()
			return _mm_shuffle_ps(a,b,0x88);
		Elif sizeof(T)==8:
			w=(int)(u32)(u64)va_arg(0)
			x=(int)(u32)((u64)va_arg(0)>>32)
			y=(int)(u32)(u64)va_arg(1)
			z=(int)(u32)((u64)va_arg(1)>>32)
			a=_mm_movelh_ps((__m128)w,(__m128)x)
			b=_mm_movelh_ps((__m128)y,(__m128)z)
			return _mm_shuffle_ps(a,b,0x88);
		Else
			/error("panic: weird int type in x86makevec")
	Elif T==f32:
		w=va_arg(0)
		x=va_arg(1)
		a=_mm_movelh_ps((__m128)w,(__m128)x)
		If n>2:
			y=va_arg(2)
			z=va_arg(3)
			b=_mm_movelh_ps((__m128)y,(__m128)z)
		Else
			b=_mm_setzero_ps()
		return _mm_shuffle_ps(a,b,0x88);
	Elif T==f64:
		return _mm_unpacklo_pd((__m128)va_arg(0),(__m128)va_arg(1))
	Else
		/write-meta.errorf("panic: weird base type ",dumptype(typeid(T))," in x86makevec")
/
	//instantize all the possibilities
	using meta
	For tid=t0_i8:t0_f64
		typedef typefromiptr(tid) T
		a=x86makevec(VectorType(T,2).typeid,(T)0,(T)0)
		If sizeof(T)<8:
			a=x86makevec(VectorType(T,4).typeid,(T)0,(T)0,(T)0,(T)0)
		a;
}

//BSGP compatibility
with detail{
const
	debugspap=!meta.getcmdlineoption("nodebug")
inline int pure1()
	__pure__
	return 1
#defhack __getrank 'metaf-fgrank'
#defhack __setoldrank 'metaf-fsork'
#defhack __getoldrank 'metaf-fgork'
#defhack __settsize 'metaf-fssize'
#defhack __gettsize 'metaf-fgsize'
#defhack __barrier__ 'metaf-bar'

import "spaprt.dll"
	int spapIsInited()
	void spapRuntimeInit()"__spaprt_init"

int spap_inited=0
%void lazyinit()
	if !.spap_inited:
		.spap_inited=1
		if !spapIsInited():spapRuntimeInit()
}
using detail
static thread
	iptr rank
		__device__ get()=detail.__getrank()
	iptr size
		%get()=detail.__gettsize()
		__host__ %set(iptr a)detail.__settsize(a)
	iptr oldrank
		%iptr get()=detail.__getoldrank()
		%set(iptr a)detail.__setoldrank(a)
#def barrier:
	using meta
	d=0
	if want(int'('):
		d=cnsexpr()
		skip(int')')
	emitcode_clear()
	write-emitcodef(;"$$spap.detail.__barrier__(",d,");")
	emitcode_flush()

//SPAP buffer
class CSPAPContainer
	//reducer: dup-empty, merge
	//broadcast: dup-same
	//migrate to other processor

with detail{
class CSPAPBuffer:CSPAPContainer
	//hardcoded CPU access
	void* _d; iptr _n; iptr _sz
	int[3]* elements
	//WARNING: the real implementation in spaprt has more members
	//......
	//the methods are always overloaded
	void* getNativePointer()
	void* getDevicePointer()
	void discard()
	void __done__()
	int _resize(iptr sz)
	int _mount(int iswrite,void* p,iptr sz)
	int unmount()
	////////////////////////////////
	novirtual inline void* _cpuptr()
		ret=._d
		if !ret:._d=ret=.getNativePointer()
		return ret
using meta
int tisdlistsimple(ttype t)
	const
		id_isvector=(iptr)getid("__is_vector")
	if tisstruct(t)&&findmember(t,(tsymbol)id_isvector):return 1
	return !tiscomplicated(t)
struct cdlistterm
	iptr ofs
	tsymbol id
	ttype t
	int gofs
	inline int operator<(cdlistterm& b)
		sza=_sizeof(.t)
		szb=_sizeof(b.t)
		return sza>szb||sza==szb&&.ofs<b.ofs
inline int byofs(cdlistterm& a,cdlistterm& b)
	return a.ofs<b.ofs
int dltisbasic(ttype t)
	return tisprimitive(t)||tis(t,ctype.tstruct)&&findmember(t,getid("__is_vector"))
//flattening
void dlflatten(int isforce,cmember* pm,iptr ofs0,cvec(cdlistterm) ts)
	if pm.what==kw_static:return
	if dltisbasic(pm.t)&&(!isforce||!tis(pm.t,ctype.tstruct)):
		with ts.add()
			.ofs=ofs0+pm.ofs
			.id=pm.id
			.t=pm.t
		return
	if tis(pm.t,ctype.tstruct):
		sd=get_Struct(pm.t)
		for pd:sd
			if pd.what!=declarable.member:continue
			pm2=(cmember*)pd.p
			dlflatten(isforce,pm2,ofs0+pm.ofs,ts)
		return
	if tis(pm.t,ctype.array):
		pt=ctype*pm.t
		t0=pt.t0
		szt0=_sizeof(t0)
		for i=0:pt.sz-1
			with cmember m2
				.what=kw_struct
				.t=t0
				.id=pm.id
				.ofs=i*szt0
			dlflatten(isforce,&m2,ofs0+pm.ofs,ts)
		return
	write-errorf('member "',dumptype(pm.t),' ',pm.id.s,'" is not supported in dlist')
void _dlflatten(int isforce,ttype t,cvec(cdlistterm) ts)
	sd=get_Struct(t)
	for pm:sd.sc.members
		dlflatten(isforce,pm,0,ts)
	curofs=0
	for i=0:ts.n-1
		if curofs>ts[i].ofs:
			write-errorf('dlist of union ',dumptype(t),' is not supported yet')
		curofs=ts[i].ofs+_sizeof(ts[i].t)
void dlflatten(ttype t,cvec(cdlistterm) ts)
	_dlflatten(0,t,ts)
int concattrait(iptr esz,iptr lst)
	return (iptr)cat(cons(esz),(clisp(iptr)*)lst)
int tis3vec(ttype t)
	const
		id_is3vec=(iptr)getid("__is_3vec")
	return tisstruct(t)&&findmember(t,(tsymbol)id_is3vec)
int tisbasevec(ttype t)
	const
		id_isbasevec=(iptr)getid("__is_vector")
	return tisstruct(t)&&findmember(t,(tsymbol)id_isbasevec)

import "spaprt.dll"
	CSPAPBuffer spapMakeList(iptr)
}

class dlist(T):CSPAPBuffer
	//this class is fake: we SHOULDN'T new it directly \
	//	or add any members or overload anything virtual!
	iptr __is_dlist{get()=1}
	If tisdlistsimple(meta.typeid(T)):{struct{
	static
		%__new__()
			lazyinit()
			return (dlist(T))spapMakeList(0)
		%__new__(iptr n)
			lazyinit()
			return (dlist(T))spapMakeList(sizeof(T)*n)
	//simple types are easy
	iptr n
		__host__ %get()=(iptr)((uptr)(._n)/(uptr)sizeof(T))
		__host__ %set(iptr n2)._resize(n2*sizeof(T))
		__precompute__ get()
			require
				ret=.n
			return ret
	iptr sz
		__host__ %get()=(iptr)((uptr)(._sz)/(uptr)sizeof(T))
		__precompute__ get()
			require
				ret=.sz
			return ret
	__operation__ T* __bracket(int a)
		default
			d=(T*)(.getDevicePointer())
			spawn ...
				...
				result=d+a
				...
		case "CPU"
			d=(T*)(._cpuptr())
			spawn ...
				...
				result=d+a
				...
	#version 1
	__operation__ T __loadold(int a)
		default
			d=(T*)(.getDevicePointer())
			spawn ...
				...
				result=d[a]
				...
		case "CPU"
			d=(T*)(._cpuptr())
			spawn ...
				...
				result=d[a]
				...
	#version 0
	T* d
		__host__ %get()=(T*)(.getDevicePointer())
		__device__ %get()=.__bracket(0)
	__device__ T& operator[](int a)=.__bracket(a)
	__device__ T& operator[](u32 a)=.__bracket((int)a)
	__host__ T& operator[](int a)=(T*)(._cpuptr())+a
	__host__ T& operator[](u32 a)=(T*)(._cpuptr())+(int)a
	__device__ T* operator+(int a)=.__bracket(a)
	__device__ T* operator+(u32 a)=.__bracket((int)a)
	__host__ T* operator+(int a)=(T*)(._cpuptr())+a
	__host__ T* operator+(u32 a)=(T*)(._cpuptr())+(int)a
	__device__ T* operator-(int a)=.__bracket(-a)
	__device__ T* operator-(u32 a)=.__bracket(-(int)a)
	__host__ T* operator-(int a)=(T*)(._cpuptr())-a
	__host__ T* operator-(u32 a)=(T*)(._cpuptr())-(int)a
	//////////////////////////////////
	__host__ inline void resize(iptr n)
		._resize(n*sizeof(T))
	void* _increment(void* p)
		dp=(iptr)p-(iptr)(._cpuptr())
		._resize(max(._sz+1,64))
		return (void*)(dp+(iptr)(._cpuptr()))
	__operation__ void push_back(T a)
		case "CPU"
			pbegin=(T*)(._cpuptr())+.n
			pend=(T*)(._cpuptr())+.sz
			spawn ...
				...
				if pbegin==pend:
					pbegin=._increment(pbegin)
					pend=(void*)((char*)(._cpuptr())+(iptr)(._sz))
				*pbegin++=a
				...
			._resize((iptr)pbegin-(iptr)(._cpuptr()))
	__host__ inline void push_back(T a)
		nn=._n
		pbegin=(void*)(iptr(._cpuptr())+nn)
		if ._n==._sz:
			pbegin=._increment(pbegin)
			nn=._n
		*(T*)pbegin=a
		._n=nn+sizeof(T)
	__host__ inline void push_back(dlist(T)* b)
		n0=.n
		.resize(n0+b.n)
		memcpy(.d+n0,b.d,b.n)
	__host__ inline void add(T a)
		.push_back(a)
	__host__ inline void add(dlist(T)* b)
		.push_back(b)
	//////////////////////////////////
	__host__ inline mount(T* p,iptr n)=._mount(1,p,n*sizeof(T))
	__host__ inline void clear()
		.resize(0)
	%__host__ __init__()
		//nothing
	__host__ inline datafrom(T* p,iptr n)
		.discard()
		.resize(n)
		spapCpyh2d(.getDevicePointer(),p,n*sizeof(T))
	__host__ inline void datafrom(cvec(T) a)
		.discard()
		.resize(a.n)
		spapCpyh2d(.getDevicePointer(),a.d,a.n*sizeof(T))
	__host__ inline void datato(cvec(T) a)
		a.resize(.n)
		memcpy(a.d,._cpuptr(),a.n*sizeof(T))
	}}Else{struct{
	//flattening is required
	iptr __is_dlist_struct{get()=1}
	/
		using meta
		t=typeid(T)
		//offset list
		ts=new cvec(cdlistterm)
		_dlflatten(0,t,ts)
		if !ts.n:write-errorf('dlist of empty struct ',dumptype(typeid(T)),' is invalid')
		//allocate-by-size
		sort(ts.begin(),ts.end())
		gofs=0
		for i=0:ts.n-1
			ts[i].gofs=gofs
			gofs+=_sizeof(ts[i].t)
		sort(ts.begin(),ts.end(),byofs)
		szmin=_sizeof(ts.back().t)
		szmin&=-szmin
		nalg=256/szmin
		emitcode_begin()
		write-emitcodef("static{__members=iptr[][3]const[[",ts.n,",",gofs,",",nalg,"],")
		for i=0:ts.n-1
			write-emitcodef('[',ts[i].ofs,',',_sizeof(ts[i].t),',',ts[i].gofs,'],')
		write-emitcodef("[-1,-1,-1]];const{__nmember=",ts.n,";__totsz=",gofs,";__nalign=",nalg,";}};")
		for i=0:ts.n-1
			write-emitcodef('typedef $$system.meta.typefromiptr(',ts[i].t,') __type',i,';')
		ts._addref()
		write-emitcodef('const{__dlistterms=',(iptr)ts,';};')
		emitcode_end()
	%__host__ void resize(iptr n2)
		._resize(n2*__totsz)
	%__host__ __init__()
		.elements=.__members+1
	static
		%__new__()
			lazyinit()
			ret=(dlist(T))spapMakeList(0)
			ret.__init__()
			return ret
		%__new__(iptr n)
			lazyinit()
			ret=(dlist(T))spapMakeList(0)
			ret.__init__()
			ret.resize(n)
			return ret
	iptr n
		inline __host__ get()=iptr((uptr)(._n)/uptr(__totsz))
		__precompute__ get()
			require
				ret=.n
			return ret
	iptr _stride
		inline __host__ get()
			n=(iptr)((uptr)(._sz)/(uptr)__totsz)
			return n&-.elements[-1][2]
	__operation__ char* _getdevptr()
		default
			st=.getDevicePointer()
			spawn ...
				...
				result=st
				...
		case "CPU"
			st=._cpuptr()
			spawn ...
				...
				result=st
				...
	__operation__ iptr _getstride()
		default
			st=._stride
			spawn ...
				...
				result=st
				...
	static int __ofs2ptr(iptr ofs)
		l=1;r=__nmember
		while l<=r
			m=(l+r)>>1
			if .__members[m][0]<=ofs:
				l=m+1
			else
				r=m-1
		if r<1||.__members[r][0]!=ofs:return -1
		return r
	inline __host__ _ofs2ptr(const tid,const ofs)
		const
			c=__ofs2ptr(ofs)
		If c==-1||.__members[c][1]!=sizeof(*(meta.typefromiptr(tid))0):
			/
				using meta
				write-errorf("invalid dlist member of type ",dumptype(((ctype*)tid).t0)," at offset ",ofs," for dlist(",dumptype(typeid(T)),").pointerof")
			return 0
		Else
			stride=._stride*.__members[c][2]
			//return (meta.typefromiptr(tid))((char*)(.getNativePointer())+stride)
			return (meta.typefromiptr(tid))((char*)(.getDevicePointer())+stride)
	inline __device__ _ofs2ptr(const tid,const ofs)
		const
			c=__ofs2ptr(ofs)
		If c==-1||.__members[c][1]!=sizeof(*(meta.typefromiptr(tid))0):
			/
				using meta
				write-errorf("invalid dlist member of type ",dumptype(((ctype*)tid).t0)," at offset ",ofs," for dlist(",dumptype(typeid(T)),").pointerof")
			return 0
		Else
			const
				cofs=.__members[c][2]
			stride=._getstride()
			ptr=._getdevptr()
			return (meta.typefromiptr(tid))(void*)(ptr+stride*cofs)
	#def pointerof:
		using meta
		pe=meta.macroobj
		if !pe:write-errorf('listof/pointerof requires object (type dlist(',dumptype(typeid(T)),'))')
		expect(int'(')
		s=gettext(gt_toch,int')')
		nextlex()
		skip(int')')
		emitcode_begin()
		write-emitcodef("(&(($$system.meta.typefromiptr(",typeid(T),")*)0)",s,");")
		emitcode_end()
		pe2=&expr();skip(int';')
		t00=pe2.t
		castto(pe2,t0_iptr)
		dum=0
		evalto(pe2,&dum)
		emitcode_begin()
		write-emitcodef("(")
		emitcode_expr(pe)
		write-emitcodef("._ofs2ptr(",t00,',',dum,'));')
		emitcode_end()
		pe3=&expr();skip(int';')
		meta.macroobj=pe3
	%__host__ __force_template operator(T*)()
		using meta
		/write-errorf("dlist(",dumptype(typeid(T)),") is a composite dlist and can't be mapped")
	static int __getDgofsDss(int ofs0,int szele)
		using meta
		//ofs0 is offset of [0], szele is size of [0]
		pm=&.__members[1]
		gofs0=-1;szme=-1
		for i=0:__nmember-1
			ofs=pm[i][0]
			if ofs>ofs0:break
			if ofs==ofs0:
				szme=pm[i][1]
				gofs0=pm[i][2]
				break
		gofs1=-1;szme2=-1
		ofs1=ofs0+szele
		for i=0:__nmember-1
			ofs=pm[i][0]
			if ofs>ofs1:break
			if ofs==ofs1:
				szme2=pm[i][1]
				gofs1=pm[i][2]
				break
		if gofs0<0||gofs1<0||szme!=szme2:
			write-errorf("panic: operator[] of dlist contains a bug: ",gofs0,' ',gofs1,' ',szme,' ',szme2,' / ',ofs0,' ',szele)
		return gofs1-gofs0
	static void __gendeltagofs(int ofs0,int sz,iptr arr_trait)
		using meta
		peszs=(clisp(iptr)*)arr_trait
		if !peszs:return
		i=0
		for(p=peszs;p;p=p.x)
			write-emitcodef("+",__getDgofsDss(ofs0,p.a)/sz,"*.ss[",i,"]")
			i++
	struct brahook(ST,const st_offset,const st_idx,const arr_depth,const arr_trait)
		using meta
		#version 1
		typedef dlist(T) Tlist
		Tlist* b
		iptr d
		//the list of array-element sizes is exposed by arr_trait
		//compile-time-array whose pointer is exposed by const arr_trait
		If arr_depth>0:
			//subscripts
			int[arr_depth] ss
		ST __auto__
			//map should be done in operator[]?
			//these are rather inefficient...
			__host__ __force_template inline ST get()
				ptr=.b._cpuptr();stride=.b._stride
				/
					emitcode_begin()
					pm=&dlist(T).__members[1]
					total_size=sizeof(ST);
					for i=st_idx:__nmember-1
						ofs=pm[i][0]-st_offset;
						if ofs>=total_size:break;
						sz=pm[i][1]
						gofs=pm[i][2]
						write-emitcodef('*(Tlist.__type',i,'*)((iptr)&result+',ofs,
							')=((Tlist.__type',i,'*)ptr)[.d+(',gofs/sz)
						__gendeltagofs(ofs+st_offset,sz,arr_trait)
						emitcode(')*stride];')
					emitcode_end()
			__host__ __force_template inline set(const ST &a)
				ptr=.b._cpuptr();stride=.b._stride
				/
					emitcode_begin()
					pm=&dlist(T).__members[1]
					total_size=sizeof(ST);
					for i=st_idx:__nmember-1
						ofs=pm[i][0]-st_offset;
						if ofs>=total_size:break;
						sz=pm[i][1]
						gofs=pm[i][2]
						write-emitcodef('((Tlist.__type',i,'*)ptr)[.d+(',gofs/sz)
						__gendeltagofs(ofs+st_offset,sz,arr_trait)
						write-emitcodef(')*stride]=*(Tlist.__type',i,'*)((iptr)&a+',ofs,');')
					emitcode_end()
			//CUDA version
			__device__ ST get()
				bb=.b
				ptr=bb._getdevptr()
				stride=bb._getstride()
				/
					emitcode_begin()
					pm=&dlist(T).__members[1]
					total_size=sizeof(ST);
					for i=st_idx:__nmember-1
						ofs=pm[i][0]-st_offset;
						if ofs>=total_size:break;
						sz=pm[i][1]
						gofs=pm[i][2]
						write-emitcodef('*(Tlist.__type',i,'*)((iptr)&result+',ofs,
							')=((Tlist.__type',i,'*)(void*)ptr)[.d+(',gofs/sz)
						__gendeltagofs(ofs+st_offset,sz,arr_trait)
						emitcode(')*stride];')
					emitcode_end()
			__device__ set(const ST &a)
				bb=.b
				ptr=bb._getdevptr()
				stride=bb._getstride()
				/
					emitcode_begin()
					pm=&dlist(T).__members[1]
					total_size=sizeof(ST);
					for i=st_idx:__nmember-1
						ofs=pm[i][0]-st_offset;
						if ofs>=total_size:break;
						sz=pm[i][1]
						gofs=pm[i][2]
						write-emitcodef('((Tlist.__type',i,'*)(void*)ptr)[.d+(',gofs/sz)
						__gendeltagofs(ofs+st_offset,sz,arr_trait)
						write-emitcodef(')*stride]=*(Tlist.__type',i,'*)((iptr)&a+',ofs,');')
					emitcode_end()
		If tis(typeid(ST),ctype.array)&&((ctype*)typeid(ST)).sz>1||tis3vec(typeid(ST)):
			/*
			array of int3
				gofs difference between 0st and 1st element
					which depends on the member of the element
				a gofs offset in brahook
				a current-array-subscript
			use linked list among template types
			*/
			If tisstruct(typeid(ST)):
				typedef ST.Telement TArrayElem
			Else
				typedef typefromiptr(((ctype*)typeid(ST)).t0) TArrayElem
			%brahook(TArrayElem,st_offset,st_idx,arr_depth+1,concattrait(sizeof(TArrayElem),arr_trait))\
			operator[](int d)
				const
					nele=((ctype*)typeid(ST)).sz
				with result
					.d=this.d;.b=this.b
					If typeof(this).arr_depth:
						For i=0:typeof(this).arr_depth-1
							.ss[i+1]=this.ss[i]
					.ss[0]=d
			__force_template %operator(TArrayElem*)()
				/write-errorf("can't obtain a pointer to an array element of dlist(",dumptype(typeid(T)),")")
		Elif thasmember(typeid(ST))
			If hasmethod(ST,operator[](ST,int))
				__force_template %operator[](int d)
					/write-errorf("non-array element ",dumptype(typeid(ST))," of dlist(",dumptype(typeid(T)),") can't be indexed yet, please use pointerof, sorry")
		If !tisbasevec(typeid(ST)):{
		inline __member__(class Tm,const mofs)
			/
				emitcode_begin()
				pm=&dlist(T).__members[1]
				t_offset=mofs+st_offset;
				i=0;
				for i=st_idx:__nmember-1
					ofs=pm[i][0]
					//sz=pm[i][1]
					if ofs==t_offset:
						goto gotit
				write-errorf("invalid member of type ",dumptype(typeid(Tm)),
					" at offset ",mofs," for dlist(",dumptype(typeid(T)),").pointerof")
				:gotit
				write-emitcodef("brahook(Tm,",t_offset,",",i,",",arr_depth,",",arr_trait,")\
result;with result{.d=this.d;.b=this.b;")
				if arr_depth:
					write-emitcodef(".ss=this.ss;")
				write-emitcodef("}");
				emitcode_end()
		}
		__force_template %operator&()
			/write-errorf("can't obtain an address of dlist(",dumptype(typeid(T)),") elements")
		#version 0
	__device__ brahook(T,0,0,0,0) operator[](int d)
		with result{.d=(iptr)d;.b=this;}
	__device__ brahook(T,0,0,0,0) operator[](u32 d)
		with result{.d=(iptr)d;.b=this;}
	__host__ inline brahook(T,0,0,0,0) operator[](int d)
		ptr=._cpuptr()
		with result{.d=(iptr)d;.b=this;}
	__host__ inline brahook(T,0,0,0,0) operator[](u32 d)
		ptr=._cpuptr()
		with result{.d=(iptr)d;.b=this;}
	__host__ inline __force_template void datafrom(T* a,int n)
		.discard()
		.resize(n)
		da=new char<sizeof(T)*n>;
		da.datafrom((char*)a,n*sizeof(T));
		/
			using meta
			emitcode_begin()
			emitcode('spawn n{T b;')
			pm=&dlist(T).__members[1]
			for i=0:__nmember-1
				ofs=pm[i][0];
				sz=pm[i][1]
				//gofs=pm[i][2]
				if ofs%sz||sizeof(T)%sz:
					write-errorf("struct ",dumptype(typeid(T))," has unaligned members and can't use datafrom")
				write-emitcodef('*(__type',i,'*)((char*)(void*)(&b)+',ofs,')=((dlist(__type',i,'))da)[',ofs/sz,'+thread.rank*',sizeof(T)/sz,'];')
			emitcode('this[thread.rank]=b;}')
			emitcode_end()
		da.discard();
	__host__ inline __force_template void datafrom(cvec(T) a)
		.datafrom(a.d,a.n)
	__host__ inline datato(T* ad,int n)
		n=.n
		da=new char<sizeof(T)*n>;
		/
			using meta
			emitcode_begin()
			emitcode('spawn n{T b;')
			emitcode('b=this[thread.rank];')
			pm=&dlist(T).__members[1]
			for i=0:__nmember-1
				ofs=pm[i][0];
				sz=pm[i][1]
				//gofs=pm[i][2]
				if ofs%sz||sizeof(T)%sz:
					write-errorf("struct ",dumptype(typeid(T))," has unaligned members and can't use datafrom")
				write-emitcodef('((dlist(__type',i,'))da)[',ofs/sz,'+thread.rank*',sizeof(T)/sz,']=*(__type',i,'*)((char*)(void*)(&b)+',ofs,');')
			emitcode("}")
			emitcode_end()
		//a.resize(n)
		//spapCpyd2h(a.d,da.d,n*sizeof(T))
		spapCpyd2h(ad,da.d,n*sizeof(T))
		da.discard()
	__host__ inline datato(cvec(T) a)
		a.clear()
		a.resize(.n)
		.datato(a.d,a.n)
	}}
	struct{
	__host__ inline void clear_resize(iptr n)
		.resize(0)
		.resize(n)
	__host__ inline void clear_resize_exact(iptr n)
		.discard()
		.resize(n)
	__host__ inline void addn(iptr n2)
		.resize(.n+n2)
	}
	__both__ iptr size()=.n

with detail{
%makelist(class T,iptr n)
	lazyinit()
	ret=(dlist(T))spapMakeList(0)
	ret.__init__()
	ret.resize(n)
	return ret
}

import "spaprt.dll"
	void* spapGetTextureHandle(void* pmod,int id)
	void* spapGetSurfaceHandle(void* pmod,int id)
	void* spapGetGpuApi(char* s)

with detail{
/////////////////////////////////////////////
//for BSGP compatibility
/meta.state('spap-tmplist-type')=(void*)meta.typeid(dlist(char))
%iptr spapGetStride(iptr sz)
	return (sz+255)&-256
%void* spapinit(int szele,iptr sz)
	lazyinit()
	spapPushLocalOptionSet()
	pl=makelist(char,szele*sz)
	pl._addref()
	return pl
%void spapdone(void* st)
	pl=(dlist(char)*)st
	pl.discard()
	pl._release()
	spapPopLocalOptionSet()
%void spaperror(int d)
	If debugspap:
		writeln('met erronous barrier id: ',d)
		readln
%void* rerank_pre(int szele,int sz)
	pl=makelist(char,szele*sz)
	pl._addref()
	return pl
%void rerank_post(void* plv)
	pl=(dlist(char)*)plv
	pl.discard()
	pl._release()

//for forall
__host__ %iptr n_forall(a,b0,c0)
	using meta
	typedef typeof(a) T
	b=(T)b0;c=(T)c0
	if b==(T)0:return 0
	if b<(T)0:
		if a<c:return 0
	else
		if a>c:return 0
	If tisint(typeid(T)):
		typedef typefromiptr(typeid(T)&-2) Tu
		return (iptr)(uptr)((Tu)(c-a)/(Tu)b)+1
	Else
		return (iptr)((c-a)/b)+1

__device__ i_forall(a,b0)
	typedef typeof(a) T
	b=(T)b0
	return a+b*(T)thread.rank

meta.cexpres getiterall(iptr vi)
	using meta
	vsrc=(cvar*)(vi&-4)
	isiterall=(vi&1)
	tcls=effstruct(vsrc.t)
	if isiterall:
		ttype[2] ts
		ts[0]=((ctype*)tcls).sd.stype;ts[1]=t0_end
		pf=findmethod(tcls,getid("__iterall__"),ts)
		return callpf0(pf.pmf,List[&makeerv(vsrc)])
	else
		perk=&callpf0(meta.state('metaf-fgrank'),new cvec(cexpres*))
		return call(getid("operator[]"),List[&makeerv(vsrc),perk])

#def from_src_forall:
	using meta
	//non-ref -> once, ref -> many-times
	//always once to prevent stupid code... ref isn't that important
	id=wantid()
	v=(cvar*)cnsexpr()
	isiterall=cnsexpr()
	pe=&getiterall((iptr)v+isiterall)
	vv=makevar(roottype__auto__(pe.t))
	declare(cdecl.variable,id,vv)
	feedstat(call("operator=",List[&makeerv(vv),pe]).code)

__device__ loadold(class T,dlist(char)* pl,int ofs,int rank,int stride)
	//return *(T*)(pl+(ofs*stride+sizeof(T)*rank))
	return ((dlist(T)*)pl).__loadold((int)((u32)ofs/(u32)sizeof(T))*stride+rank)

//for interrupt
__host__ char* getDevicePointer(dlist(char)* pl)
	return pl.getDevicePointer()
}

//per-target stuff
#defhack targeting 'metaf-targeting'
inline __float_as_int(float a)
	union uxxx
		int i
		float f
	with uxxx u
		.f=a
		return .i
inline __int_as_float(int a)
	union uxxx
		int i
		float f
	with uxxx u
		.i=a
		return .f

//distribute
with detail{
class cdisthook
	void operator()(){}

void runDistribute(void* a)
	static sta
		void wrapper(void* param)
			((cdisthook*)param)()
	n=spapGetProcessorCount()
	for i=n-1:-1:0
		spapRunAt(i,sta.wrapper,a)
	spapWaitForAll()

class CSerializeTask
	CSerializeTask* x
	void operator()(){}

struct DomainDefault
	int begin,end,step
	int batchcpu,batchgpu
	inline int operator!()=(.begin>=.end)

import "spaprt.dll"
	void spapEndDistribute()
	void spapAddSerialize(void* a)
	DomainDefault spapDefaultBatch(DomainDefault& a)

%DomainDefault make1DdomainInclusive(int b,int step,int e,int s0,int s1)with result
	.begin=b;.end=e+1;.step=step
	.batchcpu=s0;.batchgpu=s1
}

//hard-coded util functions for the GPU code generators
with detail{
%void cudevDeclShared(const alg,iptr sz)
	If alg>=16:
		typedef int4 T
	Elif alg>=8:
		typedef int2 T
	Elif alg>=4:
		typedef int T
	__asm__("@prelive",
		"__shared__ ","@type",meta.typeid(T)," __sharedbase[","@const",sz/sizeof(T),"]")
%void* cudevSetShared(int ofs)
	return (void*)__asm__("@return",meta.typeid(void*),"=(void*)((char*)(void*)__sharedbase+","@const",ofs,")")
void cudevStdKernel()
	using function_global,meta
	defglobal iptr __thread_size
	defglobal void* __kernel
	defglobal void* __param
	defglobal iptr __szparam
	n=__thread_size
	spapLaunch(__kernel,n,__param,__szparam)
	spawn 1
		defglobal iptr __thread_rank
		__thread_rank=__asm__("@return",meta.typeid(iptr),"=blockIdx.x*blockDim.x+threadIdx.x")
		if __thread_rank<__thread_size:
			__asm__("@@kernel body")
void cudevSysKernel()
	using function_global,meta
	defglobal iptr __thread_size
	defglobal void* __kernel
	defglobal void* __param
	defglobal iptr __szparam
	n=__thread_size
	spapLaunch(__kernel,n,__param,__szparam)
	spawn 1
		defglobal iptr __thread_rank
		__thread_rank=__asm__("@return",meta.typeid(iptr),"=blockIdx.x*blockDim.x+threadIdx.x")
		__asm__("@@kernel body")

void* getCudaModule()
/meta.state('metaf-getcudamodule')=(meta.cfunction*)meta.hasmethod(spap.detail,getCudaModule())
int cudaGetEndBarrier()=(int()(void*)spapGetGpuApi("cudaGetEndBarrier"))(getCudaModule())
}

#defhack spapTargetOption "metaf-taropt"
#defhack spapAllocateTexture 'metaf-allocTex'
#defhack spapAllocateSurface 'metaf-allocSurf'
with detail
	#defhack __parblock "bsgp-par"

#def par:
	using meta
	//if strcmp(meta.curtarget.name,"PTX")!=0:error("par block can only be used on device")
	first=1
	want(int':')
	skip(tok_indl)
	st=ccode null
	while !want(tok_indr):
		st=cat(st,call('$$spap.detail.__parblock',List[&makeeri(!first)]).code)
		st=cat(st,statement())
		first=0
	st=cat(st,call('$$spap.detail.__parblock',List[&makeeri(2)]).code)
	feedstat(st)

with detail{
__precompute__ void* getClassMember(void* a,int ofs)
	/meta.state('metaf-classmember')=meta.curfunc
	require
		ret=*(void**)((iptr)a+ofs)
	return ret
}
