uses windows,vfw
struct avirecorder
	const{fmt_32=0;fmt_24=1}
	BITMAPINFOHEADER bih;
	PAVIFILE pavi;
	PAVISTREAM pvid,pvidc;
	int w,h,maxfps;
	int fmt;
	int fn;
	int is1st
	void create(char *fn,int ww,int hh,int mf,int ffmt);
	void writeframe(int *buf);
	void close();
with avirecorder{

void create(char *fn,int ww,int hh,int mf,int ffmt)
	bih=BITMAPINFOHEADER const[sizeof(BITMAPINFOHEADER),0,0,1,32,BI_RGB,0]
	bih0=bih;
	bih0.biWidth=ww;bih0.biHeight=hh;
	bih0.biSizeImage=ww*hh*4;
	fmt=ffmt;
	if(fmt==fmt_24){bih0.biSizeImage=ww*hh*3;bih0.biBitCount=24;}

	AVISTREAMINFOA sinf
	memset(&sinf,0,sizeof(sinf));
	sinf.fccType=streamtypeVIDEO;
	sinf.dwScale=1;
	sinf.dwRate=mf;//maxfps
	sinf.dwSuggestedBufferSize=bih0.biSizeImage;

	pco=&AVICOMPRESSOPTIONS co
	memset(pco,0,sizeof(co));
	DeleteFileA(fn);
	AVIFileOpenA(&.pavi,fn,OF_CREATE|OF_WRITE,NULL)
	AVIFileCreateStreamA(.pavi,&.pvid,&sinf)
	AVISaveOptions(NULL,0,1,&.pvid,&pco)
	AVIMakeCompressedStream(&.pvidc,.pvid,&co,NULL)
	AVIStreamSetFormat(.pvidc,0,&bih0,bih0.biSize)
	.fn=0;
	.is1st=1

void writeframe(int *buf)
	//AVIStreamWrite(.pvidc,.fn++,1,buf,.w*.h*(.fmt==fmt_24?3:4),AVIIF_KEYFRAME,NULL,NULL)
	AVIStreamWrite(.pvidc,.fn++,1,buf,.w*.h*(.fmt==fmt_24?3:4),.is1st?AVIIF_KEYFRAME:0,NULL,NULL)
	.is1st=0

void close()
	AVIStreamClose(.pvidc);
	AVIStreamClose(.pvid);
	AVIFileClose(.pavi);

}