/*
todo:
	more COMBOBOX, WC_LISTVIEW, tree control
	support separate LISTBOX later?
	throughly change of function naming
	parent's destroy called before children's:(
dialog
	table
		hspan
		vspan
		align mode
		search for tok_eq
	radio/checkbox
		wraper
	static control
	droplist
	focus setting...
	detailed formating
		table
		x/y alignment
		whether enlarge
	additional init code
child window
window destructing?
design:
	do not be cool
	do not be general
note:
	class has autozero
	this is not thread safe! multithread should each have a first_alive
*/
uses windows
If !compiler.getcmdlineoption("private_subsystem_woo"):uses link
autouses windows
using meta,compiler
static detail
//attributes for win32 structs
with SIZE
	SIZE bigger
		set(SIZE b)
			if .cx<b.cx:.cx=b.cx
			if .cy<b.cy:.cy=b.cy
	SIZE smaller
		set(SIZE b)
			if .cx>b.cx:.cx=b.cx
			if .cy>b.cy:.cy=b.cy
	void operator/=(SIZE b)
		.cx/=b.cx
		.cy/=b.cy
	void operator*=(SIZE b)
		.cx*=b.cx
		.cy*=b.cy
with RECT
	int x
		inline get()=.left
		inline void set(int a)
			.right+=a-.left
			.left=a
	int y
		inline get()=.top
		inline void set(int a)
			.bottom+=a-.top
			.top=a
	int w
		inline get()=.right-.left
		inline void set(int a).right=.left+a
	int h
		inline get()=.bottom-.top
		inline void set(int a).bottom=.top+a
with HDC__
	HFONT font
		void set(HFONT a)SelectObject(this,a)
	HBRUSH brush
		void set(HBRUSH a)SelectObject(this,a)
	HPEN pen
		void set(HPEN a)SelectObject(this,a)
	HRGN region
		void set(HRGN a)SelectClipRgn(this,a)
	//todo: enum windows's hdc functions and chain'em here
with detail{
int myAdjustWindowRectEx(RECT* rc,int s0,int m,int s1)
	//REQUIRED especially for GL windows
	if s0&(WS_SYSMENU|WS_MAXIMIZEBOX|WS_MINIMIZEBOX):
		s0|=WS_CAPTION
	if s0&WS_CAPTION:
		s0|=WS_BORDER
	return AdjustWindowRectEx(rc,s0,m,s1)
}
class window_base
	HWND hwnd
	//linked list
	window_base* prev_alive
	window_base next_alive
	//pre-create stuff
	RECT create_rect
	int create_style
	int create_exstyle
	char* create_title
	HMENU create_hmenu
	HWND parent
	//pre-create/created attributes
	struct{
	RECT rect
		RECT get()
			if .hwnd:
				//GetWindowPlacement(.hwnd,&WINDOWPLACEMENT wp)
				GetWindowRect(.hwnd,result)
				//*result=wp.rcNormalPosition
			else
				return .create_rect
		void set(RECT r)
			if .hwnd:
				with r
					SetWindowPos(..hwnd,null,.x,.y,.w,.h,SWP_NOZORDER)
			else
				.create_rect=r
	int exstyle
		get()=.hwnd?GetWindowLongA(.hwnd,GWL_EXSTYLE):.create_exstyle
		void set(int a)
			if .hwnd:
				SetWindowLongA(.hwnd,GWL_EXSTYLE,a)
				SetWindowPos(.hwnd,null,0,0,0,0,
					SWP_NOZORDER|SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE|
					SWP_DRAWFRAME);
			else
				.create_exstyle=a
	int style
		get()=.hwnd?GetWindowLongA(.hwnd,GWL_STYLE):.create_style
		void set(int a)
			if .hwnd:
				SetWindowLongA(.hwnd,GWL_STYLE,a)
				SetWindowPos(.hwnd,null,0,0,0,0,
					SWP_NOZORDER|SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE|
					SWP_DRAWFRAME);
			else
				.create_style=a
	HMENU hmenu
		get()=.hwnd?GetMenu(.hwnd):.create_hmenu
		void set(HMENU a)
			if .hwnd:
				SetMenu(.hwnd,a)
			else
				.create_hmenu=a
	RECT client_rect
		RECT get()
			if .hwnd:
				GetClientRect(.hwnd,result)
			else
				/*
				adjusting back is <censored>... and not guranteed correct
				it's better to set client_rect first
				*/
				wr=.create_rect
				detail.myAdjustWindowRectEx(&wr,.create_style,.create_hmenu!=null,.create_exstyle)
				with result
					.x=0
					.y=0
					.w=..create_rect.w*2-wr.w
					.h=..create_rect.h*2-wr.h
		void set(RECT r)
			detail.myAdjustWindowRectEx(&r,.style,.hmenu!=null,.exstyle)
			with .rect
				.w=r.w
				.h=r.h
	char* title
		char[256] get()
			if .hwnd:
				GetWindowTextA(.hwnd,result,256)
			else
				strcpy(result,.create_title)
		void set(char* s)
			if .hwnd:
				SetWindowTextA(.hwnd,s)
			else
				.create_title=s
	}
	char* classname
		char* get()=null//for run-time's sake....
	//misc
	postcreate()
		int sw
		if .create_style&WS_MAXIMIZE:
			sw=SW_SHOWMAXIMIZED
		else if .create_style&WS_MINIMIZE:
			sw=SW_SHOWMINIMIZED
		else
			sw=SW_SHOWDEFAULT
		ShowWindow(.hwnd,sw)
		UpdateWindow(.hwnd)
	__translate(MSG& msg)=0
	__set_head()
		.prev_alive=this
		.next_alive=this
		return this
	close()=SendMessageA(.hwnd,WM_CLOSE,0,0)
	create()
		//empty, just to get inherited

class __woo_master
	window_base alivelist_head
	__init__()
		.alivelist_head=(new window_base).__set_head()
		InitCommonControls()
	__done__()
		with .alivelist_head
			.prev_alive=null
			.next_alive=null
		If !compiler.getcmdlineoption("private_subsystem_woo"):
			SetEnvironmentVariableA("__CTC_WOO_MASTER","none")
__woo_master __find_woo_master()
	If !compiler.getcmdlineoption("private_subsystem_woo"):
		char[260] s
		if GetEnvironmentVariableA("__CTC_WOO_MASTER",s,sizeof s-1):
			x=0
			read-sscanf(s;x)
			if x:
				p=(__woo_master*)x
				return p
		p=new __woo_master
		write-sprintf(s;iptr p)
		SetEnvironmentVariableA("__CTC_WOO_MASTER",s)
		return p
	Else
		return new __woo_master
//function return type is weak
__woo_master __master=__find_woo_master()
with window_base
	struct{
	__set_alive()
		fa=$__master.alivelist_head
		(.prev_alive=fa.prev_alive).next_alive=this
		.next_alive=fa;fa.prev_alive=this
	__set_dead()
		tna=.next_alive
		tpa=.prev_alive
		tpa.next_alive=tna
		tna.prev_alive=tpa
		.prev_alive=null
		.next_alive=null
	}
//MDI
class mdiframe:window_base
class mdichild:window_base
	mdiframe* owner
	mdichild next_sib
	mdichild* prev_sib
	next()=.next_sib
	struct
		int __is_mdichild
			get()=1
	create(){}//silence the warning
	create(void* parent)
	/*__done__()
		writeln("child done: ",this)
		*int*4+=4*/
with mdiframe:
	//for this to get inherited
	struct
		int __is_mdiframe
			get()=1
	HWND hwndclient
	HMENU create_hwindowmenu
	mdichild childlist_head
	RECT mdirect
		RECT get()
			if .hwndclient:
				GetWindowRect(.hwndclient,result)
				result.x=0;result.y=0
			else
				with result
					.x=0;.y=0;.w=0;.h=0
		void set(RECT r)
			if .hwndclient:
				with r
					SetWindowPos(..hwndclient,null,.x,.y,.w,.h,SWP_NOZORDER)
	OnCreate()
		with CLIENTCREATESTRUCT cc:
			.hWindowMenu=..create_hwindowmenu
			.idFirstChild=16385
		with cr=.client_rect
			..hwndclient=CreateWindowExA(
				0,"MDICLIENT",null,WS_CLIPCHILDREN|WS_CHILD|WS_VISIBLE|MDIS_ALLCHILDSTYLES,
				.x,.y,.w,.h,
				..hwnd,
				HMENU 16384,
				GetModuleHandleA(null),
				&cc)
		if !.childlist_head:
			with ch=new mdichild
				.prev_sib=ch
				.next_sib=ch
			.childlist_head=ch
		return 0
	__done__()
		if .childlist_head:
			.childlist_head.next_sib=null
	wndproc(HWND hw,UINT m,WPARAM wp,LPARAM lp)
		=(.hwndclient?
			DefFrameProcA(hw,.hwndclient,m,wp,lp):
			DefWindowProcA(hw,m,wp,lp)
		)
	__translate(MSG& msg)=TranslateMDISysAccel(.hwndclient,&msg)
	createchild(void* child)
		wb=mdichild child
		with wb
			.owner=this
			with wr=.create_rect
				ismaximized=0
				if ..create_style&WS_MAXIMIZE:
					ismaximized=1
					..create_style&=~WS_MAXIMIZE
				hw=CreateMDIWindowA(
					..classname,
					..create_title,
					..create_style,
					.x,.y,
					.w,.h,
					..parent=...hwndclient,
					GetModuleHandleA(null),
					LPARAM child)
			.postcreate()
			if ismaximized:
				SendMessageA(..hwndclient,WM_MDIMAXIMIZE,iptr hw,0)
		SendMessageA(.hwndclient,WM_MDIREFRESHMENU,0,0)
		DrawMenuBar(.hwnd)
	mdichild activechild
		get()
			hw=HWND SendMessageA(.hwndclient,WM_MDIGETACTIVE,0,0)
			if hw:
				return mdichild GetWindowLongA(hw,GWL_USERDATA)
			else
				return null
		set(mdichild c)
			SendMessageA(.hwndclient,WM_MDIACTIVATE,WPARAM c.hwnd,0)
	nextwindow()
		SendMessageA(.hwndclient,WM_MDINEXT,0,0);
	prevwindow()
		SendMessageA(.hwndclient,WM_MDINEXT,0,1);
	cascade()
		SendMessageA(.hwndclient,WM_MDICASCADE,0,0);
	tile(int f)
		SendMessageA(.hwndclient,WM_MDITILE,f,0);
	__iter__()=.childlist_head.next_sib
	__valid__(mdichild ch)
		/*writeln('begin of valid')
		write(ch,' ')
		if ch==.childlist_head||!ch:writeln('(',this,') ',.childlist_head)
		writeln('end of valid')*/
		=ch!=.childlist_head
with mdichild
	//for this to get inherited
	create(void* parent)
		(mdiframe parent).createchild(this)
class dialog:window_base
	HFONT font
		get()=(HFONT)SendMessageA(.hwnd,WM_GETFONT,0,0)
		set(HFONT hf)=SendMessageA(.hwnd,WM_SETFONT,(WPARAM)(iptr)hf,1)
	end(int c)=EndDialog(.hwnd,c)
//hidden window
class hidden_window:window_base
	postcreate()
		//intentionally left blank
		;
//window class
class window(T):T
	//wrapping menu command
	If (!hasmethod(T,OnCommand(T,int,int,HWND))&&
		hasmethod(T,OnMenuCommand(T,int))):
		OnCommand(int notifycode,int id,HWND hctrl)
			If hasmethod(T,OnMenuCommand(T,int)):
				if !hctrl:.OnMenuCommand(id)
	//static
	static{
	typedef window(T) mytype
	registered=0
	If hasmember(T,__acceltab):
		haccel=HACCEL null
	char[16] __classname
	LRESULT stdcall __wndproc(HWND hWin,UINT uMsg,WPARAM wParam,LPARAM lParam)
		mytype this
		//hEx "cc"
		if(uMsg==WM_CREATE)
			If hasmember(T,__is_mdichild):
				this=mytype((MDICREATESTRUCT*((CREATESTRUCT*lParam).lpCreateParams)).lParam)
			Else
				this=mytype((CREATESTRUCT*lParam).lpCreateParams)
			this.hwnd=hWin
			SetWindowLongA(hWin,GWL_USERDATA,iptr this)
		else
			this=mytype GetWindowLongA(hWin,GWL_USERDATA)
		with this{
		switch uMsg{
		case WM_CREATE:
			.__set_alive()
			If hasmember(T,__is_mdichild):
				fc=.owner.childlist_head
				(.prev_sib=fc.prev_sib).next_sib=mdichild this
				.next_sib=fc;fc.prev_sib=mdichild this
			If hasmethod(T,OnCreate(T)):
				return .OnCreate()
			break
		case WM_DESTROY:
			SetWindowLongA(hWin,GWL_USERDATA,0)//for later message......
			.__set_dead()
			If hasmember(T,__is_mdichild):
				._addref()
				tps=.prev_sib
				tns=.next_sib
				tps.next_sib=tns
				tns.prev_sib=tps
				.next_sib=null
				.prev_sib=null
			If hasmethod(T,OnDestroy(T)):
				.OnDestroy()
			If hasmember(T,__menutmp):
				//old menu destroyed, reload
				.create_hmenu=LoadMenuIndirectA(super.__menutmp)
			.hwnd=null
			If hasmember(T,__is_mdichild):
				._release()
			return 0
		If hasmethod(T,OnActivate(T,int,HWND)):
			If hasmember(T,__is_mdichild):
				case WM_MDIACTIVATE:
					wdeact=HWND wParam
					wact=HWND lParam
					if hWin==wdeact:
						.OnActivate(WA_INACTIVE,wact)
					else
						.OnActivate(WA_ACTIVE,wdeact)
					return 0
			Else
				case WM_ACTIVATE:.OnActivate(LOWORD(wParam),HWND lParam);=0
		If hasmethod(T,OnChar(T,int)):
			case WM_CHAR:.OnChar(int wParam);=0
		If hasmethod(T,OnClose(T)):
			case WM_CLOSE:
				if !.OnClose():return 0
				break
		If hasmethod(mytype,OnCommand(mytype,int,int,HWND)):
			case WM_COMMAND:
				.OnCommand(HIWORD(wParam),LOWORD(wParam),HWND lParam)
				If hasmember(T,__is_mdiframe):
					break
				Else
					return 0
		If hasmethod(T,OnEraseBkgnd(T)):
			case WM_ERASEBKGND:;=.OnEraseBkgnd()
		If hasmethod(T,OnGetMinMaxInfo(T,MINMAXINFO*)):
			case WM_GETMINMAXINFO:;.OnGetMinMaxInfo((MINMAXINFO*)lParam);=0
		If hasmethod(T,OnHScroll(T,int,HWND)):
			case WM_HSCROLL:{
				how=int LOWORD(wParam)
				memset(&SCROLLINFO sbi,0,sizeof sbi)
				with sbi
					.cbSize=sizeof sbi
					.fMask=SIF_ALL
				GetScrollInfo(.hwnd,SB_HORZ,&sbi)
				//from MSDN
				switch how{
				case SB_TOP:sbi.nPos=sbi.nMin;break;
				case SB_BOTTOM:sbi.nPos=sbi.nMax;break;
				case SB_LINEUP:sbi.nPos--;break;
				case SB_LINEDOWN:sbi.nPos++;break;
				case SB_PAGEUP:sbi.nPos-=sbi.nPage;break;
				case SB_PAGEDOWN:sbi.nPos+=sbi.nPage;break;
				case SB_THUMBTRACK:sbi.nPos=sbi.nTrackPos;break;
				}
				if sbi.nPos>sbi.nMax-sbi.nPage+1:sbi.nPos=sbi.nMax-sbi.nPage+1;
				if sbi.nPos<sbi.nMin:sbi.nPos=sbi.nMin;
				.OnHScroll(sbi.nPos,HWND lParam);
				=0
			}
		If hasmethod(T,OnHotKey(T,int)):
			case WM_HOTKEY:.OnHotKey(int wParam);=0
		If hasmethod(T,OnKeyDown(T,int,int)):
			case WM_KEYDOWN:.OnKeyDown(int wParam,int lParam);=0
		If hasmethod(T,OnKeyUp(T,int,int)):
			case WM_KEYUP:.OnKeyUp(int wParam,int lParam);=0
		If hasmethod(T,OnKillFocus(T,HWND)):
			case WM_KILLFOCUS:.OnKillFocus(HWND wParam);=0
		If hasmethod(T,OnLButtonDblclk(T,int,int,int)):
			case WM_LBUTTONDBLCLK:.OnLButtonDblclk(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnLButtonDown(T,int,int,int)):
			case WM_LBUTTONDOWN:.OnLButtonDown(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnLButtonUp(T,int,int,int)):
			case WM_LBUTTONUP:.OnLButtonUp(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnMButtonDown(T,int,int,int)):
			case WM_MBUTTONDOWN:.OnMButtonDown(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnMButtonUp(T,int,int,int)):
			case WM_MBUTTONUP:.OnMButtonUp(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnMove(T,int,int)):
			case WM_MOVE:
				.OnMove(LOWORD(lParam),HIWORD(lParam))
				If hasmember(T,__is_mdichild):
					break
				Else
					return 0
		If hasmethod(T,OnMoving(T,RECT*)):
			case WM_MOVING:
				.OnMoving((RECT*)lParam)
				return 1
		If hasmethod(T,OnEnterSizeMove(T)):
			case WM_ENTERSIZEMOVE:
				.OnEnterSizeMove()
				return 0
		If hasmethod(T,OnExitSizeMove(T)):
			case WM_EXITSIZEMOVE:
				.OnExitSizeMove()
				return 0
		If hasmethod(T,OnMouseMove(T,int,int,int)):
			case WM_MOUSEMOVE:.OnMouseMove(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnMouseWheel(T,int,int)):
			case WM_MOUSEWHEEL:.OnMouseWheel(
				LOWORD(wParam),i32 i16 HIWORD(wParam));=0
		If hasmethod(T,OnRButtonDown(T,int,int,int)):
			case WM_RBUTTONDOWN:.OnRButtonDown(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnRButtonUp(T,int,int,int)):
			case WM_RBUTTONUP:.OnRButtonUp(
				int wParam,
				i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=0
		If hasmethod(T,OnSetCursor(T,int)):
			case WM_SETCURSOR:=.OnSetCursor(LOWORD(lParam))
		If hasmethod(T,OnSetFocus(T,HWND)):
			case WM_SETFOCUS:
				.OnSetFocus(HWND wParam)
				If hasmember(T,__is_mdichild)||hasmember(T,__is_mdiframe):
					break
				Else
					return 0
		If hasmethod(T,OnSize(T,int,int,int)):
			case WM_SIZE:
				.OnSize(wParam,LOWORD(lParam),HIWORD(lParam))
				If hasmember(T,__is_mdichild):
					break
				Else
					return 0
		If hasmethod(T,OnSysChar(T,int)):
			case WM_SYSCHAR:if .OnSysChar(int wParam):=0;break
		If hasmethod(T,OnSysKeyDown(T,int,int)):
			case WM_SYSKEYDOWN:if .OnSysKeyDown(int wParam,int lParam):=0;break
		If hasmethod(T,OnTimer(T,int)):
			case WM_TIMER:.OnTimer(wParam);=0
		If hasmethod(T,OnVScroll(T,int,HWND)):
			case WM_VSCROLL:{
				how=int LOWORD(wParam)
				memset(&SCROLLINFO sbi,0,sizeof sbi)
				with sbi
					.cbSize=sizeof sbi
					.fMask=SIF_ALL
				GetScrollInfo(.hwnd,SB_VERT,&sbi)
				//from MSDN
				switch how{
				case SB_TOP:sbi.nPos=sbi.nMin;break;
				case SB_BOTTOM:sbi.nPos=sbi.nMax;break;
				case SB_LINEUP:if sbi.nPos>sbi.nMin:sbi.nPos--;break;
				case SB_LINEDOWN:if sbi.nPos<sbi.nMax:sbi.nPos++;break;
				case SB_PAGEUP:sbi.nPos-=sbi.nPage;if sbi.nPos<sbi.nMin:sbi.nPos=sbi.nMin;break;
				case SB_PAGEDOWN:sbi.nPos+=sbi.nPage;if sbi.nPos>sbi.nMax:sbi.nPos=sbi.nMax;break;
				case SB_THUMBTRACK:
					sbi.nPos=sbi.nTrackPos;
					if sbi.nPos<sbi.nMin:sbi.nPos=sbi.nMin;
					if sbi.nPos>sbi.nMax:sbi.nPos=sbi.nMax;
					break;
				}
				if sbi.nPos>sbi.nMax-sbi.nPage+1:sbi.nPos=sbi.nMax-sbi.nPage+1;
				if sbi.nPos<sbi.nMin:sbi.nPos=sbi.nMin;
				.OnVScroll(sbi.nPos,HWND lParam);
				=0
			}
		If hasmethod(T,OnPaint(T,HDC)):
			case WM_PAINT:
				\hdc=BeginPaint(.hwnd,&PAINTSTRUCT \ps)
				.OnPaint(hdc)
				EndPaint(.hwnd,&ps)
				=0
		Else
			If hasmethod(T,OnPaint(T)):
				case WM_PAINT:.OnPaint();=0
		}
		If hasmethod(T,wndproc(T,HWND,UINT,WPARAM,LPARAM)):
			if this:
				return .wndproc(hWin,uMsg,wParam,lParam)
			else
				If hasmember(T,__is_mdichild):
					return DefMDIChildProcA(hWin,uMsg,wParam,lParam)
				Else
					return DefWindowProcA(hWin,uMsg,wParam,lParam)
		Else
			If hasmember(T,__is_mdichild):
				return DefMDIChildProcA(hWin,uMsg,wParam,lParam)
			Else
				return DefWindowProcA(hWin,uMsg,wParam,lParam)
		}
	If hasmember(T,__dlgtmp):
		int stdcall __dlgproc(HWND hWin,UINT uMsg,WPARAM wParam,LPARAM lParam)
			mytype this
			if(uMsg==WM_INITDIALOG)
				this=mytype(lParam)
				this.hwnd=hWin
				SetWindowLongA(hWin,DWL_USER,iptr this)
			else
				this=mytype GetWindowLongA(hWin,DWL_USER)
				if !this:return 0
			with this{
			switch(uMsg){
			case WM_INITDIALOG:
				.__set_alive()
				.__dlg_init()
				If hasmethod(T,OnInitDialog(T)):
					return .OnInitDialog()
				Else
					return 1
			case WM_DESTROY:
				:isdestroy
				.__dlg_sync()
				SetWindowLongA(hWin,DWL_USER,0)
				.__set_dead()
				.hwnd=null
				return 1
			case WM_CLOSE:
				If hasmethod(T,OnClose(T)):
					if !.OnClose():
						return 1
				EndDialog(hWin,0)
				goto isdestroy
				//return 1
			If hasmethod(T,OnCtrlCommand(T,int,int)):
				case WM_HSCROLL:
				case WM_VSCROLL:
					if !lParam:return 0
					return .OnCtrlCommand($$woo.detail.ctrl_slider,GetDlgCtrlID(HWND lParam))
				case WM_COMMAND:
					return .OnCtrlCommand(HIWORD(wParam),LOWORD(wParam))
			If hasmethod(T,OnActivate(T,int,HWND)):
				If hasmember(T,__is_mdichild):
					case WM_MDIACTIVATE:
						wdeact=HWND wParam
						wact=HWND lParam
						if hWin==wdeact:
							.OnActivate(WA_INACTIVE,wact)
						else
							.OnActivate(WA_ACTIVE,wdeact)
						return 1
				Else
					case WM_ACTIVATE:.OnActivate(LOWORD(wParam),HWND lParam);=0
			If hasmethod(T,OnHotKey(T,int)):
				case WM_HOTKEY:.OnHotKey(int wParam);=0
			If hasmethod(T,OnMouseMove(T,int,int,int)):
				case WM_MOUSEMOVE:.OnMouseMove(
					int wParam,
					i32 i16 LOWORD(lParam),i32 i16 HIWORD(lParam));=1
			If hasmethod(T,OnTimer(T,int)):
				case WM_TIMER:.OnTimer(wParam);=0
			default:
				:isdefault
				If hasmethod(T,dlgproc(T,HWND,UINT,WPARAM,LPARAM)):
					if this:
						return .dlgproc(hWin,uMsg,wParam,lParam)
				return 0
			}
			}
	void ready()
		sprintf(.__classname,"_w%08x",meta.typeid(T))
		memset(&WNDCLASS wc,0,sizeof wc)
		with wc
			If hasmethod(T,OnLButtonDblclk(T,int,int,int)):
				.style=CS_BYTEALIGNWINDOW|CS_DBLCLKS
			Else
				.style=CS_BYTEALIGNWINDOW
			.lpfnWndProc=..__wndproc
			.hInstance=GetModuleHandleA(null)
			.hbrBackground=HBRUSH(GetStockObject(NULL_BRUSH))
			.hCursor=LoadCursorA(null,IDC_ARROW)
			.lpszClassName=..__classname
		RegisterClassA(&wc)
		If hasmember(T,__acceltab):
			.haccel=CreateAcceleratorTableA(
				super.__acceltab,
				sizeof super.__acceltab/sizeof ACCEL)
		.registered=1
	}
	//dynamic
	char* classname
		char* get()=mytype.__classname
	create()
		/*If hasmember(T,__menutmp):
			.create_hmenu=LoadMenuIndirectA(super.__menutmp)*/
		wr=.create_rect
		with wr
			hw=CreateWindowExA(
				..create_exstyle,
				..__classname,
				..create_title,
				..create_style,
				.x,.y,
				.w,.h,
				..parent,..create_hmenu,
				GetModuleHandleA(null),
				this)
		if hw&&.parent:SetParent(hw,.parent)
		.postcreate()
	If hasmember(T,__dlgtmp):
		DoModal(HWND owner)
			//writeln(void*(T.__dlgtmp))
			//ret
			=DialogBoxIndirectParamA(GetModuleHandleA(null),void*(T.__dlgtmp),owner,.__dlgproc,LPARAM this)
			/*
			write('error: ',windows.error)
			return ret
			*/
		create(HWND owner)
			hw=CreateDialogIndirectParamA(
				GetModuleHandleA(null),
				void*(T.__dlgtmp),
				owner,
				.__dlgproc,
				LPARAM this)
			if .parent:
				SetParent(hw,.parent)
			.postcreate()
	__init__()
		If hasmethod(T,__init__(T)):
			super.__init__(void* this)
		if !mytype.registered: mytype.ready()
		.create_style=WS_OVERLAPPEDWINDOW
		.create_title="untitled"
		If hasmember(T,__menutmp):
			.create_hmenu=LoadMenuIndirectA(super.__menutmp)
		If hasmember(T,__windowmenupos):
			.create_hwindowmenu=GetSubMenu(.hmenu,super.__windowmenupos)
	If hasmember(T,__acceltab):
		__translate(MSG& msg)
			if TranslateAcceleratorA(.hwnd,.haccel,&msg):return 1
			return super.__translate(void* this,msg)
	If hasmember(T,__dlgtmp):
		__translate(MSG& msg)
			if msg.hwnd==.hwnd||IsChild(.hwnd,msg.hwnd):
				If hasmethod(T,OnChar(T,int)):
					if msg.message==WM_CHAR:
						if .OnChar(int msg.wParam):
							return 1
				If hasmethod(T,OnKeyDown(T,int,int)):
					if msg.message==WM_KEYDOWN:
						if .OnKeyDown(int msg.wParam,int msg.lParam):
							return 1
			if IsDialogMessageA(.hwnd,&msg):return 1
			return super.__translate(void* this,msg)
//menu
with detail{
lvec(short) menutmp
lvec(ACCEL) acceltab
int curmenuid
int windowmenupos
void menu_addwstr(char* s)
	for(p=s;*p;p++)
		.menutmp.add(short(*p))
	.menutmp.add(short 0)
void declmenuitem(int pos);
void declmenu(int istopmost)
	last=-1
	skip(tok_indl)
	int pos
	if istopmost:{pos=0}else pos=-1
	while !want(tok_indr):
		last=.menutmp.n
		declmenuitem(pos)
		if istopmost:pos++
	if last==-1:
		with .menutmp
			last=.n
			.add(short 0)
			.add(short 0)
			.add(short 0)
	.menutmp.d[last]|=MF_END
void declmenuitem(int pos)
	if want(int';'):
	else if want(tok_mm):
		//separator
		with .menutmp
			.add(short 0)
			.add(short 0)
			.add(short 0)
	else if got(tok_str):
		//menu/pop-up
		char[66] akname
		char[65] kname
		s=wantstr()
		id=.curmenuid
		hasaccel=0
		aknamefilled=0
		if want(int'('):
			with $detail.acceltab:
				while !want(int')'):
					if got(tok_str):
						//string form
						sk=wantstr()
						if strlen(sk)>64:error("key name too long")
						if !hasaccel:
							strcpy(akname,sk)
							aknamefilled=1
						s0=sk
						fv=FVIRTKEY
						vk=0
						isend=0
						for(ps=sk;!isend;ps++)
							isend=!*ps
							if *ps=='+'||!*ps:
								if s0:
									*ps=0
									if strcmp(s0,"CTRL")==0:
										strcpy(kname,"FCONTROL")
									else
										write-sprintf(kname;"F",s0)
									if findmember(typeid(windows),getid(kname)):
										eval(kname,t0_iptr,&int tmp)
										fv|=tmp
									else
										write-sprintf(kname;"VK_",s0)
										if findmember(typeid(windows),getid(kname)):
											eval(kname,t0_iptr,&int \tmp)
											if vk==0:
												vk=tmp
											else
												error("duplicate vk")
										else if strlen(s0)==1:
											if vk==0:
												vk=(int)s0[0]
											else
												error("duplicate vk")
										else
											error("unknown key")
									s0=null
							else
								if !s0:s0=ps
								*ps=toupper(int(*ps))
						with .add()
							if vk==0:error("vk unspecified")
							.cmd=id
							.fVirt=fv
							.key=vk
					else
						with .add()
							.cmd=id
							.fVirt=cnsexpr()
							skip(int':')
							.key=cnsexpr()
					if!want(int','):want(int';')
					hasaccel=1
		with .menutmp
			if got(int':')://note gettext's overwriting behavior
				//code
				code=gettext(gt_functemp|gtf_stripindent|gtf_addlineinfo)
				write-emitcodef(;"case ",id,":",code,"break;")
				.add(short 0)
				.add(short id)
				..curmenuid++
			else if want(int';')||got(tok_indr)
				//dummy
				.add(short 0)
				.add(short id)
				..curmenuid++
			else if got(tok_indl)
				if hasaccel:error("popup can't have accelerator")
				.add(short MF_POPUP)
				menu_addwstr(s)
				declmenu(0)
				return
			else error("menu item syntax error")
		menu_addwstr(s)
		if aknamefilled:
			with .menutmp
				.n--
				.add(short'\t')
			menu_addwstr(akname)
	else if got(tok_id):
		idw=wantid()
		if idw==getid("other_command"):
			expect(int':')
			code=gettext(gt_functemp|gtf_stripindent|gtf_addlineinfo)
			write-emitcodef(;"default:",code,"break;")
			goto iddone
		if idw!=getid("window"):error("'window' expected")
		if pos==-1:error("MDI window menu has to be topmost")
		with .menutmp
			.add(short MF_POPUP)
		s=got(tok_str)?wantstr():"&Window"
		menu_addwstr(s)
		if got(tok_indl):
			declmenu(0)
		.windowmenupos=pos
		:iddone
	else error("menu syntax error")

//dialog
struct dialogAST
	const
		leaf=0
		horizontal=1
		vertical=2
	dialogAST* x,c
	int what
	char* txt
	//position doesn't have to be saved
	SIZE sz,szmax
	//leaf only
	char* wc
	int wci
	iptr t
	tsymbol name
	char* code
	int style
	iptr id
	union
		double __aligner
		int[8] extra
with dialogAST
	//util
	z()
		memset(this,0,sizeof(*this))
		return this
const
	dialog_infinite=0x3f3f3f3f
	ctrl_button=0x80
	ctrl_edit=0x81
	ctrl_static=0x82
	ctrl_listbox=0x83
	ctrl_combobox=0x85
	ctrl_slider=0x10001//also act as a made-up notify...
	ctrl_treeview=0x10002
HWND temp_dlg
HDC temp_dc
SIZE dlgunit
lvec(char) sync_code
lvec(char) init_code
lvec(char) ctrl_code
lvec(char) cinit_code
lvec(char) cctrl_code
int stdcall dummy_dlgproc(HWND hWin,UINT uMsg,WPARAM wParam,LPARAM lParam)=0
void decldlgitemmisc(dialogAST* nd)
	with nd.szmax
		.cx=dialog_infinite
		.cy=dialog_infinite
	switch nd.wci{
	case ctrl_button:
		if !nd.style: nd.style=WS_TABSTOP|BS_PUSHBUTTON
		break
	case ctrl_edit:
		nd.style=WS_BORDER|WS_TABSTOP|ES_AUTOHSCROLL
		break
	case ctrl_slider:
		nd.style=WS_TABSTOP|TBS_NOTICKS
		break
	case ctrl_static:
		nd.style=0
		break
	case ctrl_treeview:
		nd.style=TVS_DISABLEDRAGDROP|TVS_HASLINES|TVS_HASBUTTONS|TVS_SHOWSELALWAYS
		break
	case ctrl_listbox,ctrl_combobox:
		break;
	default:
		nd.style=WS_TABSTOP
		break
	}
	for(;;)
		if want(int'<'):
			//upper bound
			skip(int'(')
			nd.szmax.cx=cnsexpr()
			skip(int',')
			nd.szmax.cy=cnsexpr()
			skip(int')')
		else if want(int'>'):
			//lower bound
			skip(int'(')
			nd.sz.cx=cnsexpr()
			skip(int',')
			nd.sz.cy=cnsexpr()
			skip(int')')
		else if got(tok_id)&&__tok_id()==getid("#"):
			//option
			nextlex()
			opt=wantstr()
			skip(int'(')
			if strcmp(opt,"style")==0:
				//style
				nd.style=cnsexpr()
			else if strcmp(opt,"id")==0:
				nd.id=cnsexpr()
			else if strcmp(opt,"range")==0:{
				labslice(cexpres ra,cexpres rb,cexpres rc)
				castto(&ra,nd.t)
				castto(&rb,nd.t)
				castto(&rc,nd.t)
				if !ra.iscns()||!rb.iscns()||!rc.iscns():
					error("constant range expected")
				sz=_sizeof(nd.t)
				evalto(&ra,nd.extra)
				evalto(&rb,char*nd.extra+sz)
				evalto(&rc,char*nd.extra+sz*2)
			}else if strcmp(opt,"text")==0:
				nd.txt=wantstr()
			else if strcmp(opt,"size")==0:
				nd.sz.cx=nd.szmax.cx=cnsexpr()
				skip(int',')
				nd.sz.cy=nd.szmax.cy=cnsexpr()
			else if strcmp(opt,"data")==0:
				//todo: combobox data in nd.extra
			else
				while !got(int')')&&!got(EOF):
					nextlex()
			skip(int')')
		else break
	if nd.what==dialogAST.leaf:
		SIZE tsz
		switch nd.wci{
		case ctrl_treeview:
			with tsz
				.cx=128
				.cy=256
			break
		case ctrl_slider:
			with tsz
				.cx=64
				.cy=14
			break
		case ctrl_button:
		case ctrl_static:
			//writeln(nd.txt)
			andn=0
			for(s=nd.txt;*s;s++)
				if *s=='&':
					andn++
					s++
			GetTextExtentPoint32A(
				.temp_dc,
				nd.txt,strlen(nd.txt),
				&tsz)
			tsz/=.dlgunit
			tsz.cx-=andn*4
			if nd.wci==ctrl_button:
				with tsz
					.cx+=10
					.cy+=4
			break
		default:
			with tsz
				.cx=8
				.cy=8
			break
		}
		with RECT trect
			.x=0;.y=0
			.w=tsz.cx
			.h=tsz.cy
		AdjustWindowRect(&trect,nd.style,0)
		tsz.cx=trect.w
		tsz.cy=trect.h
		nd.sz.bigger=tsz
		if nd.wci==ctrl_static:
			nd.szmax.smaller=tsz
//current "type"
dialogAST curdlgitemtype
dialogAST* decldialog()
	while want(int';')||want(int','):;
	if got(tok_indr):return null
	if want(tok_indl){
		t0=t=dialogAST* null
		while !want(tok_indr):
			t2=decldialog()
			if !t2:continue
			if t:
				t.x=t2
			else
				t0=t2
			t=t2
			t2.x=null
		return t0
	}else if want(tok_oo):
		nd=(new dialogAST).z()
		nd.what=dialogAST.horizontal
		:isgroup
		with nd
			.txt=got(tok_str)?wantstr():char* null
			.c=decldialog()
	else if want(tok_eq):
		nd=(new dialogAST).z()
		nd.what=dialogAST.vertical
		goto isgroup
	else if got(tok_str):
		//static......
		with nd=(new dialogAST).z()
			.what=leaf
			.wc=null
			.wci=ctrl_static
			.txt=wantstr()
	else if got(tok_id)
		//identifier......
		id=wantid()
		nd=new dialogAST
		*nd=$detail.curdlgitemtype
		nd.name=id
		if want(int'*'):
			expect(tok_str)
			nd.txt=wantstr()
		else
			nd.txt=*(char**)(id)
		decldlgitemmisc(nd)
		if got(int':'):
			nd.code=gettext(gt_functemp|gtf_stripindent|gtf_addlineinfo)
		return nd
	else if want(int'+'): with $detail.curdlgitemtype.z()
		/*
		EDIT.char*
		EDIT.int
		type would be followed by identifier and strings, so there's no ambiguity
		*/
		//recognizing the known classes......
		//captain and text and ......, goes with identifier
		.what=leaf
		.style=0
		.wc=null
		.wci=0
		id=wantid()
		switch iptr id{
		case meta.getidentifier(EDIT):
			.wci=ctrl_edit
			break
		case meta.getidentifier(BUTTON):
			.wci=ctrl_button
			break
		case meta.getidentifier(CHECKBOX):
			.wci=ctrl_button
			.style=WS_TABSTOP|BS_AUTOCHECKBOX
			break
		case meta.getidentifier(LISTBOX):
			.wci=ctrl_listbox
			.style=WS_BORDER|WS_TABSTOP|WS_VSCROLL|LBS_HASSTRINGS|LBS_NOTIFY
			break
		case meta.getidentifier(COMBOBOX):
			.wci=ctrl_combobox
			.style=WS_TABSTOP|WS_VSCROLL|CBS_DROPDOWNLIST//|CBS_HASSTRINGS
			break
		case meta.getidentifier(SLIDER):
			.wc=TRACKBAR_CLASSA
			.wci=ctrl_slider
			break
		case meta.getidentifier(TREEVIEW):
			.wc=WC_TREEVIEWA
			.wci=ctrl_treeview
			break
		default:
			error("unknown pre-defined control class")
			break
		}
		if want(int'.'):
			.t=atype()
		else
			.t=t0_unknown
		//todo: string class stuff
		return decldialog()
	else error("dialog syntax")
	decldlgitemmisc(nd)
	return nd
//find max{min} and expand
void dfsdialog(dialogAST* t)
	with t
		for(i=.c;i;i=i.x)
			dfsdialog(i)
		switch .what{
		case dialogAST.leaf:
			break
		case dialogAST.vertical:
			cx=.sz.cx
			cy=0
			for(i=.c;i;i=i.x)
				if cx<i.sz.cx: cx=i.sz.cx
				cy+=i.sz.cy
			.sz.cx=cx+(.txt?10:2)
			.sz.cy=cy+(.txt?18:2)
			for(i=.c;i;i=i.x)
				if i.szmax.cx>cx: i.szmax.cx=cx
				if i.sz.cx<i.szmax.cx: i.sz.cx=i.szmax.cx
			break
		case dialogAST.horizontal:
			cy=.sz.cy
			cx=0
			for(i=.c;i;i=i.x)
				if cy<i.sz.cy: cy=i.sz.cy
				cx+=i.sz.cx
			.sz.cx=cx+(.txt?10:2)
			.sz.cy=cy+(.txt?18:2)
			for(i=.c;i;i=i.x)
				if i.szmax.cy>cy: i.szmax.cy=cy
				if i.sz.cy<i.szmax.cy: i.sz.cy=i.szmax.cy
			break
		}
//set dialog size and do generation
char* allocstr(char *s)
	l=strlen(s)+1;
	r=new[l]char
	return memcpy(r,s,l)
void adddlgitem(dialogAST* t,int x,int y)
	with .menutmp
		if .n&1:.add(short 0)
		t.style|=WS_VISIBLE
		.add(short t.style);.add(short(t.style>>16))
		.add(short 0);.add(short 0)
		.add(short x)
		.add(short y)
		.add(short t.sz.cx)
		.add(short t.sz.cy)
		.add(short t.id)
		if t.wc:
			menu_addwstr(t.wc)
			//no need of alignment?
		else
			.add(short -1)
			.add(short t.wci)
		if t.txt:
			menu_addwstr(t.txt)
		else
			.add(short 0)
		.add(short 0)//creation data
void setdialog(dialogAST* t,int x,int y)
	with t
		switch .what{
		case dialogAST.leaf:
			//template generation
			id=$detail.curmenuid++//need ++ to count # of items...
			if .id==0:
				.id=id
			else
				id=.id
			adddlgitem(t,x,y)
			if t.name:{
				//todo: calling event handling code in dlgproc, by emitting static if...
				s=*char**(t.name)
				if t.t!=t0_unknown:
					char* sc
					char* ic
					switch t.wci{
					case ctrl_combobox:
						//todo: combobox init
					default:
						sc=allocstr(char* write-strprintf(;"$$woo.detail.GetDlgItemParc(this,",.wci,',',t.id,",&.__cache_",s,");"))
						ic=allocstr(char* write-strprintf(;"$$woo.detail.SetDlgItemParc(this,",.wci,',',t.id,",.__cache_",s,");"))
						break
					case ctrl_slider:
						//generate the const
						write-emitcodef(;"static{__extra",t.id,"=int[]const[");
						for i=0:7
							write-emitcodef(;t.extra[i],',')
						emitcode("];}")
						..init_code.addstr(char* write-strprintf(;"$$woo.detail.SetSliderRange(this,",t.id,",.__extra",t.id,",.__cache_",s,");"))
						sc=allocstr(char* write-strprintf(;"$$woo.detail.GetSlider(this,",t.id,",.__extra",t.id,",&.__cache_",s,");"))
						ic=allocstr(char* write-strprintf(;"$$woo.detail.SetSlider(this,",t.id,",.__extra",t.id,",.__cache_",s,");"))
						break
					}
					..sync_code.addstr(sc)
					..init_code.addstr(ic)
					write-emitcodef(;
						"meta.typefromiptr(",t.t,") __cache_",s,";",
						"meta.typefromiptr(",t.t,") ",s,"{",
						"get(){",sc,"return .__cache_",s,";}")
					if t.t==typeid(char*):
						write-emitcodef(;
							"set(char* x){if .__cache_",s,":delete .__cache_",s,";.__cache_",s,"=$$woo.detail.allocstr(x);",ic,"}};"
							)
					else
						write-emitcodef(;
							"set(meta.typefromiptr(",t.t,") x){",".__cache_",s,"=x;",ic,"}};"
							)
					delete ic
					delete sc
				if t.code||t.t==t0_unknown:
					if !t.code:t.code=""
					..cctrl_code.addstr(char* write-strprintf(;
						//:$$woo.detail.__dialog_ctrl_base
						"class __class0_",s,"{__dialog_mytype* owner;const{id=",.id,",__wci=",t.wci,";};};",
						"class __class_",s,":$$woo.detail.__dialog_ctrl0(__class0_",s,"){",t.code,";};",
						"$$woo.detail.__dialog_ctrl(__class_",s,") __ctrl_",s,";"))
					..ctrl_code.addstr(char* write-strprintf(;"case ",.id,":{if .__ctrl_",s,":.__ctrl_",s,".__on_notify(c);break;}"))
					..cinit_code.addstr(char* write-strprintf(;"(.__ctrl_",s,"=new $$woo.detail.__dialog_ctrl(__class_",s,")).owner=this;"))
					if t.t==t0_unknown:
						..cctrl_code.addstr(char* write-strprintf(;"$$woo.detail.__dialog_ctrl(__class_",s,") ",s,"{get()=.__ctrl_",s,"};"))
			}
			break
		case dialogAST.horizontal:
		case dialogAST.vertical:
			if t.txt:{
				//grouping
				t.id=$detail.curmenuid++
				t.style=WS_VISIBLE|WS_GROUP|BS_GROUPBOX
				t.wc=null
				t.wci=ctrl_button
				t.sz.cy-=4
				adddlgitem(t,x,y)
				t.sz.cy+=4
				x+=4
				y+=10
			}
			x++;y++
			for(i=.c;i;i=i.x)
				dx=dy=0
				if t.what==dialogAST.horizontal
					dy=(t.sz.cy-i.sz.cy)>>1
				setdialog(i,x+dx,y+dy)
				if t.what==dialogAST.horizontal
					x+=i.sz.cx
				else
					y+=i.sz.cy
			break
		}
//run-time stuff
class __dialog_ctrl0(T):T
	HWND hctrl
		get()=GetDlgItem(.owner.hwnd,T.id)
	disable()=EnableWindow(.hctrl,0)
	enable()=EnableWindow(.hctrl,1)
	char* text
		char[256] get()
			GetWindowTextA(.hctrl,result,256)
		void set(char* s)
			SetWindowTextA(.hctrl,s)
	HFONT font
		get()=(HFONT)SendMessageA(.hctrl,WM_GETFONT,0,0)
		set(HFONT hf)=SendMessageA(.hctrl,WM_SETFONT,(WPARAM)(iptr)hf,1)
	If T.__wci==ctrl_edit:
		ReplaceSel(char* s,int u)=SendMessageA(.hctrl,EM_REPLACESEL,u,LPARAM s)
		SetSel(int s,int e)=SendMessageA(.hctrl,EM_SETSEL,s,e)
	If T.__wci==ctrl_listbox:
		clear()
			SendMessageA(.hctrl,LB_RESETCONTENT,0,0)
		add(char* s)
			SendMessageA(.hctrl,LB_ADDSTRING,0,(iptr)s)
		int n
			get()=SendMessageA(.hctrl,LB_GETCOUNT,0,0)
		int sel
			get()=SendMessageA(.hctrl,LB_GETCURSEL,0,0)
		char* operator[](int d)
			lg=SendMessageA(.hctrl,LB_GETTEXTLEN,d,0)
			if lg<=0:return null
			s=new char[lg+1]
			SendMessageA(.hctrl,LB_GETTEXT,d,(iptr)s)
			return s
	If T.__wci==ctrl_treeview:
		//todo
class __dialog_ctrl(T):T
	//const{__wci=T.super.super.__wci}
	__on_notify(int c)
		switch c{
		If __wci==ctrl_button:
			If hasmethod(T,OnClick(T)):
				case BN_CLICKED:.OnClick();break;
		If __wci==ctrl_slider:
			If hasmethod(T,OnChange(T)):
				case ctrl_slider:.OnChange();break;
		If __wci==ctrl_edit:
			If hasmethod(T,OnChange(T)):
				case EN_CHANGE:.OnChange();break;
			If hasmethod(T,OnSetFocus(T)):
				case EN_SETFOCUS:.OnSetFocus();break;
			If hasmethod(T,OnKillFocus(T)):
				case EN_KILLFOCUS:.OnKillFocus();break;
		If __wci==ctrl_listbox:
			If hasmethod(T,OnDblclk(T)):
				case LBN_DBLCLK:.OnDblclk();break;
			If hasmethod(T,OnSelChange(T)):
				case LBN_SELCHANGE:.OnSelChange();break;
			If hasmethod(T,OnSetFocus(T)):
				case LBN_SETFOCUS:.OnSetFocus();break;
		If __wci==ctrl_treeview:
			//todo
		}
	If __wci==ctrl_slider:
		SetResolution(int res)
			SendMessageA(.hctrl,TBM_SETRANGE,1,MAKELONG(0,res))
			/
				emitcode_clear()
				write-emitcodef(;".owner.__extra",T.super.super.id,"[6]=res;")
				emitcode_flush()
GetDlgItemParc(this,int clsitem,int iditem,pparc)
	with this{
	If !tispointer(typeid(typeof(pparc))):
		/error("internal error: non-pointer passed to GetDlgItemParc")
	if !.hwnd:return
	hitem=GetDlgItem(.hwnd,iditem)
	switch clsitem{
	case ctrl_combobox:
		ret=SendMessageA(hitem,CB_GETCURSEL,0,0)
		If typeid(typeof(pparc))==typeid(char**):
			lg=SendMessageA(hitem,CB_GETLBTEXTLEN,ret,0)
			s=new[lg+1]char
			SendMessageA(hitem,CB_GETLBTEXT,ret,(iptr)s)
			if *pparc:delete *pparc
			*pparc=s
		Else
			*pparc=ret
		break
	case ctrl_edit:
		lg=GetWindowTextLengthA(hitem)+1
		s=new[lg]char
		GetWindowTextA(hitem,s,lg)
		If typeid(typeof(pparc))==typeid(char**):
			if *pparc:delete *pparc
			*pparc=s
		Else
			read-sscanf(s;*pparc)
			delete s
		break
	case ctrl_button:
		If typeid(typeof(*pparc))==t0_i32:
			*pparc=SendMessageA(hitem,BM_GETCHECK,0,0)
		break
	}
	}
SetDlgItemParc(this,int clsitem,int iditem,parc)
	with this{
	if !.hwnd:return
	with lvec(char) str
		.init()
	hitem=GetDlgItem(.hwnd,iditem)
	switch clsitem{
	case ctrl_combobox:
		If typeid(typeof(parc))==typeid(int):
			ret=SendMessageA(hitem,CB_SETCURSEL,parc,0)
		Elif typeid(typeof(parc))==typeid(char*):
			write-lvec_sprintf(str;parc)
			SendMessageA(hitem,CB_SELECTSTRING,-1,(iptr)parc)
		break
	case ctrl_edit:
		If typeid(typeof(parc))==typeid(char*):
			if !parc:break
		write-lvec_sprintf(str;parc)
		SetWindowTextA(hitem,str.d)
		break
	case ctrl_button:
		If typeid(typeof(parc))==t0_i32:
			SendMessageA(hitem,BM_SETCHECK,parc,0)
		break
	}
	str.done()
	}
GetSlider(this,int iditem,int* extra,pparc)
	with this{
	If !tispointer(typeid(typeof(pparc))):
		/error("internal error: non-pointer passed to GetDlgItemParc")
	typedef typeof(*pparc) T
	if !.hwnd:return
	prange=T*(extra)
	hitem=GetDlgItem(.hwnd,iditem)

	v=SendMessageA(hitem,TBM_GETPOS,0,0)
	*pparc=(prange[2]-prange[0])*T(v)/T(extra[6])+prange[0]
	}
SetSlider(this,int iditem,int* extra,parc)
	with this{
	typedef typeof(parc) T
	if !.hwnd:return
	prange=T*(extra)
	hitem=GetDlgItem(.hwnd,iditem)

	v=int((parc-prange[0])*T(extra[6])/(prange[2]-prange[0]))
	SendMessageA(hitem,TBM_SETPOS,1,v)
	}
SetSliderRange(this,int iditem,int* extra,parc)
	//we just use parc to get a type
	const
		maxres=16384
	with this{
	typedef typeof(parc) T
	if !.hwnd:return
	prange=T*(extra)
	hitem=GetDlgItem(.hwnd,iditem)

	r=prange[2]-prange[0]
	if r>=T(maxres)*prange[1]:
		res=maxres
	else
		res=int(r/prange[1])
		if res<1:res=1
	extra[6]=res
	SendMessageA(hitem,TBM_SETRANGE,1,MAKELONG(0,res))
	}
}
/
	$detail.menutmp.init()
	$detail.acceltab.init()
	$detail.sync_code.init()
	$detail.init_code.init()
	$detail.ctrl_code.init()
	$detail.cinit_code.init()
	$detail.cctrl_code.init()
def MENU:
	/*
	generates OnMenuCommand, __menutmp and maybe __acceltab
	*/
	//header
	$detail.curmenuid=10
	$detail.windowmenupos=-1
	with $detail.menutmp
		.clear()
		.add(short 0)
		.add(short 0)
	$detail.acceltab.clear()
	//body
	emitcode_clear()
	emitcode("OnMenuCommand(int id){switch id{")
	expect(tok_indl)
	$detail.declmenu(1)
	//finish
	emitcode("}}static{__menutmp=short[]const[")
	for i:$detail.menutmp
		write-emitcodef(;*i,",")
	emitcode("]")
	write-emitcodef(;";const __max_menuid=",$detail.curmenuid)
	if $detail.windowmenupos>=0:
		write-emitcodef(;";__windowmenupos=",$detail.windowmenupos)
	if $detail.acceltab.n:
		emitcode(";__acceltab=ACCEL[]const[")
		for i:$detail.acceltab
			with i:
				write-emitcodef(;'[',int(.fVirt),',',.key,',',.cmd,"],")
				//writeln(int(.fVirt),',',.key,',',i.cmd)
		emitcode("]")
	emitcode("};")
	emitcode_flush()
def DIALOG:
	/*
	build AST
	fit to maxmin
	create template and generate code
		each member's
			property
				caching
				get
				set
				ctrl's message handling
				should work for both modal and modeless
					on-end sync
				call templated function
			message handler
				pushy buttons
			special code for radios
		use inheritance to add fixed functions
		member requiring window class would need run-time init
		how to measure the sizes?
			HDC......
				use the desktop
				should be ok, just an instant, and we don't draw anything
	MENU in dialog
	need a parser to convert commctrl.h
		only write when in desperate need...
	*/
	fontface="Tahoma"
	fontsz=12
	title=wantstr()
	dstyle=DS_CENTER|WS_SYSMENU
	while !got(int':')
		if want(int'('):
			fontface=wantstr()
			skip(int',')
			fontsz=cnsexpr()
			skip(int')')
		else if want(int'='):
			dstyle=cnsexpr()
		else error("dialog declaration syntax")
	skip(int':')
	t=(new detail.dialogAST).z()
	with t
		.what=detail.dialogAST.vertical
		.txt=got(tok_str)?wantstr():char* null
	//DLGTEMPLATE
	$detail.curmenuid=8192
	with $detail.menutmp
		dstyle|=DS_SETFONT|DS_MODALFRAME
		.clear()
		.add(short dstyle);.add(short(dstyle>>16))
		.add(short 0);.add(short 0)
		.add(short 0)//# of items, filled later
		.add(short 0)
		.add(short 0)
		//size, filled later
		.add(short 0)
		.add(short 0)
		.add(short 0)//menu
		.add(short 0)//class
		detail.menu_addwstr(title)
		.add(short fontsz)
		detail.menu_addwstr(fontface)
	//create measuring stuff
	$detail.temp_dlg=CreateDialogIndirectParamA(
		GetModuleHandleA(null),
		void* $detail.menutmp.d,
		null,
		$detail.dummy_dlgproc,0)
	$detail.temp_dc=GetDC($detail.temp_dlg)
	$detail.temp_dc.font=HFONT SendMessageA($detail.temp_dlg,WM_GETFONT,0,0)
	//measure window frame
	GetWindowRect($detail.temp_dlg,&RECT m_wr)
	GetClientRect($detail.temp_dlg,&RECT m_cr)
	with m_cr
		.w=m_wr.w-.w
		.h=m_wr.h-.h
	with RECT m_dr
		.x=0;.y=0;.w=1;.h=1
	MapDialogRect($detail.temp_dlg,&m_dr)
	with $detail.dlgunit
		.cx=m_dr.w
		.cy=m_dr.h
	//dialog body
	t.c=$detail.decldialog()
	$detail.dfsdialog(t)
	//emit code
	$detail.sync_code.clear()
	$detail.init_code.clear()
	$detail.ctrl_code.clear()
	$detail.cinit_code.clear()
	$detail.cctrl_code.clear()
	emitcode_clear()
	emitcode("struct{")
	emitcode("typedef meta.typefromiptr(system.compiler.Struct_get_type(system.compiler.active_Struct())) __dialog_mytype;")
	$detail.setdialog(t,0,0)
	with $detail.menutmp
		*int*(.d)|=WS_VISIBLE
		.d[4]=$detail.curmenuid-8192
		.d[7]=t.sz.cx+m_cr.w/m_dr.w
		.d[8]=t.sz.cy+m_cr.h/m_dr.h
		if .n&1:.add(short 0)
	//control class code
	$detail.cctrl_code.add(char 0)
	emitcode($detail.cctrl_code.d)
	//init code
	emitcode("__dlg_init(){")
	$detail.init_code.add(char 0)
	emitcode($detail.init_code.d)
	emitcode("}")
	//sync code
	emitcode("__dlg_sync(){")
	$detail.sync_code.add(char 0)
	emitcode($detail.sync_code.d)
	emitcode("}")
	//message handling
	emitcode("OnCtrlCommand(int c,int id){switch id{")
	$detail.ctrl_code.add(char 0)
	emitcode($detail.ctrl_code.d)
	emitcode("default: =0;}=1;}")
	//__init__
	emitcode("__init__(){")
	$detail.cinit_code.add(char 0)
	emitcode($detail.cinit_code.d)
	emitcode("}")
	//emit template
	emitcode("}static{__dlgtmp=int[]const[")
	with $detail.menutmp
		for i=0:2:.n-1
			write-emitcodef(;(.d[i]&0xffff)|((int(.d[i+1]))<<16),",")
	emitcode("];}")
	emitcode_flush()
	ReleaseDC($detail.temp_dlg,$detail.temp_dc)
	DestroyWindow($detail.temp_dlg)
//misc stuff
typedef window_base plain_window
int handleui()
	ret=1
	while(PeekMessageA(&MSG msg,null,0,0,PM_REMOVE))
		if msg.message==WM_QUIT:ret=0
		fa=$__master.alivelist_head
		for(i=fa.next_alive;i!=fa;i=i.next_alive)
			if i.__translate(msg):goto skipstdmsgloop
		TranslateMessage(&msg)
		DispatchMessageA(&msg)
		:skipstdmsgloop
	return ret
//can't use this when having non-woo window around
with detail{
inline int donothing()=1
}
void msgloop(eachloop)
	while(GetMessageA(&MSG msg,null,0,0))
		fa=$__master.alivelist_head
		for(i=fa.next_alive;i!=fa;i=i.next_alive)
			if i.__translate(msg):goto skipstdmsgloop
		TranslateMessage(&msg)
		DispatchMessageA(&msg)
		:skipstdmsgloop
		if !eachloop():break
void msgloop()msgloop(detail.donothing)
void idle_msgloop(onidle)
	while handleui()
		onidle()
//common dialog wrapper
openfile(char* tmp,char* ext,char* buf,iptr sz,int flags)
	memset(&OPENFILENAME ofn,0,sizeof ofn)
	with ofn
		.lStructSize=sizeof ofn
		.lpstrFilter=tmp
		.lpstrDefExt=ext
		.lpstrFile=buf
		.nMaxFile=sz
		.Flags=OFN_NOCHANGEDIR|flags
	return GetOpenFileNameA(&ofn)
saveasfile(char* tmp,char* ext,char* buf,iptr sz,int flags)
	memset(&OPENFILENAME ofn,0,sizeof ofn)
	with ofn
		.lStructSize=sizeof ofn
		.lpstrFilter=tmp
		.lpstrDefExt=ext
		.lpstrFile=buf
		.nMaxFile=sz
		.Flags=OFN_NOCHANGEDIR|OFN_PATHMUSTEXIST|OFN_OVERWRITEPROMPT|flags
	return GetSaveFileNameA(&ofn)
choosefont(LOGFONTA* p,HWND hw,int flags)
	memset(&CHOOSEFONTA cf,0,sizeof cf)
	with cf
		.lStructSize=sizeof cf
		.hwndOwner=hw
		.lpLogFont=p
		.Flags=CF_FORCEFONTEXIST|CF_SCREENFONTS|flags
	return ChooseFontA(&cf)
//dockbar
class dockbar:window_base
	//should be a top-level window
	const
		dock_none=0
		dock_top=1
		dock_bottom=2
		dock_left=3
		dock_right=4
	int docking
	RECT myrect
	window_base body
	struct{
	novirtual void dockout()
	novirtual void dockin(int how)
	novirtual void dockrect(int how,RECT* dst)
	create(w)
		.body=(window_base)w
		.exstyle=WS_EX_APPWINDOW|WS_EX_TOOLWINDOW
		.style=WS_OVERLAPPED|WS_SYSMENU|WS_SIZEBOX|WS_CAPTION
		.create()
		.myrect=.rect
		with w
			.parent=..hwnd
			.style=WS_CHILD|WS_VISIBLE|WS_POPUP
			If hasmember(typeof(w),__dlgtmp):
				.create(..hwnd)
			Else
				.create()
			with .rect
				.x=0
				.y=0
				.w=this.client_rect.w
				.h=this.client_rect.h
		return w
	}
	OnSize(int f,int w,int h)
		if .body:
			with .body.rect
				.x=0;.y=0
				.w=w;.h=h
	//void OnEnterSizeMove()
	void OnExitSizeMove()
	int OnClose()
	void OnDestroy()
class dockframe:mdiframe
	cvec(window(dockbar)) bars
	__init__()
		If hasmethod(super,__init__(super))
			super.__init__(super this)
		.bars=new cvec(window(dockbar))
	int OnCreate()
	void OnDestroy()
	__done__()
		super.__done__(super this)
	RECT dockrect
		get()=.client_rect
	void resizeframe()
		if !.hwnd:return
		rc0=.dockrect
		for pb:.bars
			ShowWindow(pb.hwnd,SW_HIDE)
		for pb:.bars
			rc=pb.rect
			with rc
				with POINT pt
					.x=..left;.y=..top
				ScreenToClient(..hwnd,&pt)
				.left=pt.x;.top=pt.y
				with pt
					.x=..right;.y=..bottom
				ScreenToClient(..hwnd,&pt)
				.right=pt.x;.bottom=pt.y
			switch(pb.docking){
			default:
			break;case dockbar.dock_left:
				if rc.left!=rc0.left||rc.top!=rc0.top||rc.bottom!=rc0.bottom:
					SetWindowPos(pb.hwnd,null,rc0.left,rc0.top,rc.w,rc0.h,SWP_NOZORDER|SWP_NOACTIVATE)
			break;case dockbar.dock_right:
				if rc.right!=rc0.right||rc.top!=rc0.top||rc.bottom!=rc0.bottom:
					SetWindowPos(pb.hwnd,null,rc0.right-rc.w,rc0.top,rc.w,rc0.h,SWP_NOZORDER|SWP_NOACTIVATE)
			break;case dockbar.dock_top:
				if rc.top!=rc0.top||rc.left!=rc0.left||rc.right!=rc0.right:
					SetWindowPos(pb.hwnd,null,rc0.left,rc0.top,rc0.w,rc.h,SWP_NOZORDER|SWP_NOACTIVATE)
			break;case dockbar.dock_bottom:
				if rc.bottom!=rc0.bottom||rc.left!=rc0.left||rc.right!=rc0.right:
					SetWindowPos(pb.hwnd,null,rc0.left,rc0.bottom-rc.h,rc0.w,rc.h,SWP_NOZORDER|SWP_NOACTIVATE)
			}
			rc=pb.rect
			with rc
				with pt
					.x=..left;.y=..top
				ScreenToClient(..hwnd,&pt)
				.left=pt.x;.top=pt.y
				with pt
					.x=..right;.y=..bottom
				ScreenToClient(..hwnd,&pt)
				.right=pt.x;.bottom=pt.y
			switch(pb.docking){
			default:
			break;case dockbar.dock_left:rc0.left=rc.right
			break;case dockbar.dock_right:rc0.right=rc.left
			break;case dockbar.dock_top:rc0.top=rc.bottom
			break;case dockbar.dock_bottom:rc0.bottom=rc.top
			}
		for pb:.bars
			ShowWindow(pb.hwnd,SW_SHOWNOACTIVATE)
		.mdirect=rc0
	OnSize(int f,int w,int h)
		.resizeframe()
//////////////////////
If !compiler.getcmdlineoption("private_subsystem_woo"):
	unique window(dockframe)* dockto
Else
	window(dockframe)* dockto=null
with dockframe
	OnCreate()
		ret=super.OnCreate(super this)
		$dockto=(void*)this
		return ret
	OnDestroy()
		if (void*)$dockto==(void*)this:
			$dockto=null
with dockbar
	novirtual void dockout()
		if .docking==dock_none:return
		GetCursorPos(&POINT cur)
		x=cur.x-.myrect.w/2;y=cur.y-GetSystemMetrics(SM_CYCAPTION)/2
		.docking=dock_none
		tar=$dockto
		if !tar||!tar.hwnd:return
		SetParent(.hwnd,null)
		with .rect
			.w=..myrect.w
			.h=..myrect.h
			.x=x
			.y=y
		bs=tar.bars
		for i=0:bs.n-1
			if (void*)bs[i]==(void*)this:
				for j=i:bs.n-2
					bs[j]=bs[j+1]
				bs.resize(bs.n-1)
				break
		tar.resizeframe()
	novirtual void dockin(int how)
		.docking=how
		tar=$dockto
		if !tar||!tar.hwnd:return
		bs=tar.bars
		for i=0:bs.n-1
			if (void*)bs[i]==(void*)this:
				tar.resizeframe()
				return
		POINT pt
		pt.x=.rect.x;pt.y=.rect.y
		ScreenToClient(tar.hwnd,&pt)
		SetParent(.hwnd,tar.hwnd)
		with .rect
			.x=pt.x
			.y=pt.y
		bs=tar.bars
		bs.add(window(dockbar)this)
		tar.resizeframe()
	novirtual void dockrect(int how,RECT* dst)
		wframe=$dockto
		if !wframe||!wframe.hwndclient:return
		RECT rcc
		GetWindowRect(wframe.hwndclient,&rcc)
		switch how{
		default:
		break;case dock_none:
		break;case dock_top:
			with dst
				.y=rcc.top
				.left=rcc.left
				.right=rcc.right
				.h=dst.h
		break;case dock_bottom:
			with dst
				.left=rcc.left
				.right=rcc.right
				.h=dst.h
				.y=rcc.bottom-.h
		break;case dock_left:
			with dst
				.x=rcc.left
				.w=dst.w
				.top=rcc.top
				.bottom=rcc.bottom
		break;case dock_right:
			with dst
				.w=dst.w
				.x=rcc.right-.w
				.top=rcc.top
				.bottom=rcc.bottom
		}
	void OnExitSizeMove()
		dst=.rect
		wframe=$dockto
		if !wframe||!wframe.hwndclient:return
		//rcf=wframe.rect
		RECT rcc
		GetWindowRect(wframe.hwndclient,&rcc)
		how=dock_none
		ctrl=GetAsyncKeyState(VK_CONTROL)<0
		if !ctrl:
			if dst.w<=dst.h&&dst.h<rcc.h:
				if dst.top<=rcc.top:
					how=dock_top
				elif dst.bottom>=rcc.bottom:
					how=dock_bottom
			if dst.w<rcc.w:
				if dst.left<=rcc.left:
					how=dock_left
				elif dst.right>=rcc.right:
					how=dock_right
			if dst.w>dst.h&&dst.h<rcc.h:
				if dst.top<=rcc.top:
					how=dock_top
				elif dst.bottom>=rcc.bottom:
					how=dock_bottom
			//if .docking!=dock_none:how=.docking
		switch how{
		default:
			.dockrect(how,&dst)
		break;case dock_none:
			.dockout()
			.myrect=.rect
		}
		if how!=dock_none:
			if .docking!=dock_none:
				.dockout()
			.rect=dst
			.dockin(how)
	int OnClose()
		if GetForegroundWindow()==.hwnd:
			wframe=$dockto
			if wframe&&wframe.hwnd:
				SetForegroundWindow(wframe.hwnd)
		return 1
	void OnDestroy()
		wframe=$dockto
		if wframe:
			bs=wframe.bars
			for i=0:bs.n-1
				if (void*)bs[i]==(void*)this:
					for j=i:bs.n-2
						bs[j]=bs[j+1]
					bs.resize(bs.n-1)
					wframe.resizeframe()
					break
with dockframe
	novirtual void create_docked(wnd,int how,int x,int y,int w,int h)
		with new window(dockbar)
			.title=wnd.title
			with RECT rc
				.x=x;.y=y
				.w=w;.h=h
			.dockrect(how,&rc)
			.rect=rc
			.create(wnd)
			if how!=dock_none:
				.dockin(how)
	novirtual void close_docked(wnd)
		for pb:.bars
			if (void*)pb.body==(void*)wnd:
				pb.close()
				return
//tree view
class treeview:window_base
	HWND hwtree
	int tvstyle
	__init__()
		If hasmethod(super,__init__(super)):
			super.__init__(super this)
		.tvstyle=TVS_DISABLEDRAGDROP|TVS_HASLINES|TVS_HASBUTTONS|TVS_SHOWSELALWAYS
	OnCreate()
		rc=.client_rect
		.hwtree=CreateWindowExA(
			0,WC_TREEVIEWA,null,
			WS_CHILD|WS_VISIBLE|.tvstyle,
			0,0,rc.w,rc.h,
			.hwnd,
			NULL,
			GetModuleHandleA(null),
			NULL)
		return 0
	OnSize(int f,int w,int h)
		rc=.client_rect
		SetWindowPos(.hwtree,null,0,0,rc.w,rc.h,SWP_NOZORDER|SWP_NOACTIVATE)
	OnDestroy()
		.hwtree=null
	OnActivate(int f,HWND hw)
		if f!=WA_INACTIVE:
			SetFocus(.hwtree)
	//////////////////
	HIMAGELIST himl
		novirtual %get()=TreeView_GetImageList(.hwtree,TVSIL_NORMAL)
		novirtual %set(HIMAGELIST h)
			TreeView_SetImageList(.hwtree,h,TVSIL_NORMAL);
	struct item
		treeview* owner
		HTREEITEM hitem
		__complete__
		item j
			%item get()
				result.owner=.owner
				result.hitem=TreeView_GetParent(.owner.hwtree,.hitem)
		item l
			%item get()
				result.owner=.owner
				result.hitem=TreeView_GetChild(.owner.hwtree,.hitem)
		item i
			%item get()
				result.owner=.owner
				result.hitem=TreeView_GetPrevSibling(.owner.hwtree,.hitem)
		item k
			%item get()
				result.owner=.owner
				result.hitem=TreeView_GetNextSibling(.owner.hwtree,.hitem)
		TVITEMEXA data
			TVITEMEXA get()
				with result
					.mask=TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_HANDLE
					.pszText=NULL
					.cchTextMax=0
				TreeView_GetItem(.owner.hwtree,result)
			%set(TVITEMEXA a)
				TreeView_SetItem(.owner.hwtree,&a)
		%expand()
			TreeView_Expand(.owner.hwtree,.hitem,TVE_EXPAND)
		%collapse()
			TreeView_Expand(.owner.hwtree,.hitem,TVE_COLLAPSE)
		%select()
			TreeView_SelectItem(.owner.hwtree,.hitem)
	item root
		novirtual %item get()
			result.owner=this
			result.hitem=TreeView_GetRoot(.hwtree)
	HFONT font
		novirtual %get()=(HFONT)SendMessageA(.hwtree,WM_GETFONT,0,0)
		novirtual %set(HFONT hf)
			SendMessageA(.hwtree,WM_SETFONT,(WPARAM)hf,1)
	static
		TVITEMEXA makeitem(int img,char* s,void* param)
			//note: s may be LPSTR_TEXTCALLBACK
			with result
				.mask=TVIF_PARAM|TVIF_TEXT
				if img>=0:
					.mask|=TVIF_IMAGE|TVIF_SELECTEDIMAGE
					.iImage=img
					.iSelectedImage=img
				.lParam=(LPARAM)param
				.pszText=s
				.cchTextMax=0
	item additem(item mom,TVITEMEXA me)
		with TV_INSERTSTRUCT ti
			.hParent=mom.hitem
			.hInsertAfter=TVI_LAST
			.itemex=me
		result.owner=this
		result.hitem=TreeView_InsertItem(.hwtree,&ti)

with detail{
ccontext* mycontext
/
	.mycontext=context_snapshot()
HIMAGELIST make_sil(HIMAGELIST himl,char* buf,int ofs,int ckey)
	hdc=GetDC(NULL)
	hbmp=CreateDIBitmap(hdc,(void*)buf,CBM_INIT,(void*)(buf+ofs),(void*)buf,DIB_RGB_COLORS)
	ImageList_AddMasked(himl,hbmp,ckey)
	ImageList_SetBkColor(himl,CLR_NONE)
	DeleteObject(hbmp)
	ReleaseDC(NULL,hdc)
	return himl
}
#def StaticImageList:
	static sta
		int ilc=0
	skip(int'(')
	fn=wantstr()
	skip(int',')
	cx=cnsexpr()
	skip(int',')
	cy=cnsexpr()
	skip(int',')
	ckey=cnsexpr()
	skip(int')')
	f=fopen(fn,"rb")
	if !f:write-errorf('unable to open file ',fn)
	fseek(f,0,SEEK_END)
	sztot=ftell(f)
	fseek(f,0,SEEK_SET)
	BITMAPFILEHEADER bfh
	fread(&bfh,sizeof(bfh),1,f)
	sname=write-strprintf("__imglist_data",sta.ilc)
	id=getid((char*)sname)
	context_push(detail.mycontext)
	buf=decldata(makearraytype(t0_i8,sztot-sizeof(bfh)),id)
	context_pop()
	fread(buf,sztot-sizeof(bfh),1,f)
	fclose(f)
	bih=(BITMAPINFOHEADER*)buf
	szctab=4*bih.biClrUsed
	sz2nd=0
	cflg=0
	switch bih.biBitCount{
	default:write-errorf('unrecognized bit count ',sz2nd,' in ',fn)
	break;case 1:sz2nd=8
	break;case 4,8:
		if !szctab:szctab=(4<<(int)bih.biBitCount)
		sz2nd=szctab
		if bih.biBitCount==4:
			cflg=ILC_COLOR4
		else
			cflg=ILC_COLOR8
	break;case 16,32:
		if bih.biCompression==BI_RGB:
			sz2nd=0
		else
			sz2nd=12
		sz2nd+=szctab
		if bih.biBitCount==4:
			cflg=ILC_COLOR16
		else
			cflg=ILC_COLOR32
	break;case 24:
		sz2nd=szctab
		cflg=ILC_COLOR24
	}
	if bih.biWidth%cx||bih.biHeight%cy:
		write-warningf('incorrect image size ',bih.biWidth,'x',bih.biHeight,', should be multiply of ',cx,'x',cy)
	nimg=bih.biWidth/cx*bih.biHeight/cy
	pe=&call('$$windows.ImageList_Create',List[
		&makeeri(cx),&makeeri(cy),
		&makeeri(cflg|ILC_MASK),
		&makeeri(nimg),
		&makeeri(0),
	])
	sdata=new string('$$woo.detail.')+sname
	pe2=&call('$$woo.detail.make_sil',List[
			pe,
			&txtexpr((char*)sdata),
			&makeeri(sz2nd+sizeof(*bih)),
			&makeeri(ckey)])
	feedexpr(pe2)
	sta.ilc++
/////////////////////////////////////
If compiler.__is_user_specified():{
class testwnd:mdichild
	OnSize(int f,int w,int h)
		InvalidateRect(.hwnd,null,0)
	OnPaint(HDC hdc)
		r=.client_rect
		with r
			Rectangle(hdc,.x,.y,.w,.h)
		return 0
class testwnd_master:mdiframe
	MENU
		"&File"
			"&Open"("Ctrl+O"):
				puts("open")
			--
			"E&xit"("Alt+X"):
				DestroyWindow(.hwnd)
		"&Edit"
		window
			"..."
	OnDestroy()
		PostQuitMessage(0)
class testdlg:dialog
	DIALOG "Test dialog"=DS_CENTER:
		==
			||
				"&Integer:"
				+EDIT.int int0 #"size"(64,0)
			||
				"&String:"
				+EDIT.char* str0 #"text"("T_T") #"size"(64,0)
			||
				"&Float:"
				+EDIT.float float0 >(64,0)
			||
				"int1:"
				+EDIT.int int1e >(32,0):
					OnChange()
						.owner.int1=.owner.int1e
				+SLIDER.int int1 #"range"(0:100):
					OnChange()
						.owner.int1e=.owner.int1
			||
				+LISTBOX aaaa0 >(64,32):
				+COMBOBOX.int aaaaa >(64,0):
			||
				"double1:"
				+EDIT.double double1e >(32,0):
					OnChange()
						.owner.double1=.owner.double1e
				+SLIDER.double double1 #"range"(-1.0:0.:1.0):
					OnChange()
						.owner.double1e=.owner.double1
			||
				== "Group1"
					+BUTTON.int radio1 *"Radio 1" #"style"(WS_TABSTOP|BS_AUTORADIOBUTTON)
					+BUTTON.int radio2 *"Radio 2" #"style"(WS_TABSTOP|BS_AUTORADIOBUTTON)
			||
				== "Group2"
					+BUTTON.int radio3 *"Radio 3" #"style"(WS_TABSTOP|BS_AUTORADIOBUTTON)
					+BUTTON.int radio4 *"Radio 4" #"style"(WS_TABSTOP|BS_AUTORADIOBUTTON)
			||
				+BUTTON OK #"id"(IDOK):
					OnClick()
						writeln("OK!")
						.owner.end(0)
				+BUTTON Cancel #"id"(IDCANCEL):
					OnClick()
						writeln("cancel!")
						.owner.end(1)
			||
				+TREEVIEW tview
	OnInitDialog()
		.int1e=.int1
		.aaaa0.add("---")
		SendMessageA(.__ctrl_aaaaa.hctrl,CB_ADDSTRING,0,iptr("xxx"))
		SendMessageA(.__ctrl_aaaaa.hctrl,CB_ADDSTRING,0,iptr("yyy"))
		.aaaaa=1//"yyy"
		return 0
+
	d=new window(testdlg)
	d.int0=1234
	d.int1e=50
	d.double1e=0.5
	d.str0="^_^"
	d.float0=1.234f
	d.radio2=1
	writeln(d.DoModal(null))
	writeln(d.int0,' ',d.int1,' ',d.double1,' ',d.str0,' ',d.float0:4:4)
	writeln(d.radio1,' ',d.aaaaa)
	w=new window(testwnd_master)
	with w
		with .client_rect
			.w=640
			.h=480
		with .rect
			.x=0
			.y=0
		.title="test window"
		.style|=WS_MAXIMIZE
	w.create()
	for i=0:3
		writeln("creating: ",i)
		with new window(testwnd)
			char[64] buf
			with .client_rect
				.w=100
				.h=100
			with .rect
				.x=i*32
				.y=i*32
			write-sprintf(buf;"child #",i+1)
			.title=buf
			.create(w)
	msgloop()
}
/*
changelog
071025  window closing bug fix
071019  mdiframe onsize bug fix
071016	#ify
070821  getwindowplacement for rect, mdirect
070326	DIALOG usable (31k)
070302	MDI (14k)
070301	MENU (10k)
*/
